#undef WRITE_BINARY

#define ALIGN(pos) \
    if (pos&3) pos = (pos&~3)+4;

struct dime_data {
    char dime;

    char buffer[12];
    char *name;
    unsigned long namepos;

    FILE *f;
    unsigned long buffered;
    unsigned long remains;
    unsigned long remainspad;
    unsigned long skip;

    unsigned short optionslength;
    unsigned short idlength;
    unsigned short typelength;

    char moredata;
};

size_t writefunc(char *ptr, size_t sizefake, size_t nmemb, struct dime_data *dd) {
    long i;
    size_t size = nmemb;
    
    if (!dd->dime) {
	if ((*(char*)ptr!=60)&&(*(char*)ptr!=32)) dd->dime=1;
	else {
	    if (((char*)ptr)[2]!='D') dd->dime=-1;
	    else {
		printf("+");
		dd->dime=-2;
	    }
	}
    }
    
    if (dd->dime<0) {
	if (dd->dime==-2) {
//	    fwrite(ptr,sizefake,nmemb,stdout);
	}
	//return fwrite(ptr,sizefake,nmemb,(FILE*)stream);
	return nmemb;
    } else {
	unsigned long pos = 0;
	
	dd->moredata = 0;
	while (size>0) {
	    if (dd->optionslength) {
		if (dd->optionslength>size) {
		    dd->optionslength-=size;
		    return nmemb;
		} else {
		    pos+=dd->optionslength;
		    size-=dd->optionslength;
		    dd->optionslength = 0;
		}
	    }
	    
	    if (dd->idlength) {
		if (dd->idlength>size) {
		    memcpy(dd->name+dd->namepos, ptr+pos, size);
		    dd->namepos+=size;
		    dd->idlength -= size;
		    return nmemb;
		} else {
		    memcpy(dd->name+dd->namepos, ptr+pos, dd->idlength);
		    dd->name[dd->namepos+dd->idlength]=0;
		    if ((dd->remains)&&(strcasecmp(dd->name,"SOAP_message"))) {
			for (i=0;i<dd->namepos+dd->idlength;i++)
			    if (dd->name[i]=='/') dd->name[i]='_';

#ifdef WRITE_BINARY
			f = fopen(dd->name, "w");
#endif
		    }
		    free(dd->name);
		    
		    pos+=dd->idlength;
		    size-=dd->idlength;
		    dd->idlength = 0;
		}
		dd->optionslength = dd->typelength;
		continue;
	    }

	    if (dd->remains) {
		if (dd->remains>size) {
/*		if (f)
#ifdef WRITE_BINARY
			fwrite(ptr+pos, 1, size, f);
#else
			;
#endif
		    else if (stream) fwrite(ptr+pos, 1, size, (FILE*)stream);*/
		    dd->remains-=size;
//		    printf("Writed: size: %lu, remains: %lu\n", size, dd->remains);
		    return nmemb;
		}
/*		if (f) {
#ifdef WRITE_BINARY
		    fwrite(ptr+pos, 1, remains, f);
#else
			;
#endif
#ifdef WRITE_BINARY
		    fclose(f);
#endif
		    f = NULL;
		} else if (stream) fwrite(ptr+pos, 1, remains, (FILE*)stream);*/
		size-=dd->remains;
	        pos+=dd->remains;
		dd->remains = 0;
		dd->optionslength = dd->remainspad;
		continue;
	    }
	
	    if (size+dd->buffered<12) {
		if (size) memcpy(dd->buffer,ptr+pos,size);
		dd->buffered = size;
		return nmemb;
	    }
	
	    memcpy(dd->buffer+dd->buffered, ptr+pos, 12-dd->buffered);
	    size-=(12-dd->buffered);
	    pos+=(12-dd->buffered);
	    dd->buffered = 0;
	    
	    dd->optionslength=ntohs(*(uint16_t*)(dd->buffer+2));
	    ALIGN(dd->optionslength);
    
	    dd->idlength=ntohs(*(uint16_t*)(dd->buffer+4));
	    if (dd->idlength) dd->name = (char*)malloc(dd->idlength+1);
	    
	    dd->typelength=ntohs(*(uint16_t*)(dd->buffer+6));
	    ALIGN(dd->typelength);
	    if (dd->idlength&3) dd->typelength+=(4-dd->idlength&3);

	    dd->remains=ntohl(*(uint32_t*)(dd->buffer+8));
	    if (dd->remains&3) dd->remainspad = 4 - dd->remains&3;
	    else dd->remainspad = 0;
	    
	    if ((*dd->buffer)&64) {
		if (size) dd->moredata = 1;
		else dd->moredata=-1;
	    }
	    
	    dd->namepos = 0;
//	    printf("Sizes: %lu %lu %lu\n",optionslength, idlength, typelength);
//	    printf("Data: %lu\n",remains);
	}
    } 
    if (dd->moredata) dd->moredata=-1;
    return nmemb;
}
