#define _DS_INCLUDE_XML_HEADERS

#include <stdio.h>
#include <stdint.h>
#include <curl/curl.h>

#include <dstime.h>
#include <dsxml.h>
#include "dime.h"


CURL *curl;

double smin=1E+10, smax=0, smid=0;
double rmin=1E+10, rmax=0, rmid=0;
unsigned long iters=0;

int mainloop() {
    CURLcode res;
    FILE *thefile;
    xmlDocPtr doc;
    xmlNodePtr node;
    double time1, time2, time3, duration;
    const char *rcvtime, *replytime;
    struct DSTimeT otime1, otime2;
    struct DSDurationT oduration;
    struct timeval tm1, tm2, tm3;
    
    char request[256]="<GetStatus xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"/>";
//    char request[256]="<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Examples/random\"><Item ItemName=\"complex\"/></ItemList></Read>";
//    char request[256]="<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Example\"><Item ItemName=\"Item3\"/></ItemList></Read>";
//    char request[8192]="<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><soap:Envelope xmlns:SOAPSDK1=\"http://www.w3.org/2001/XMLSchema\" xmlns:SOAPSDK2=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:SOAPSDK3=\"http://schemas.xmlsoap.org/soap/encoding/\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"><soap:Body xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><Browse BrowseFilter=\"all\" ItemName=\"\" ItemPath=\"\" MaxElementsReturned=\"0\" ReturnAllProperties=\"false\" ReturnErrorText=\"false\" ReturnPropertyValues=\"false\"><PropertyNames>dataType</PropertyNames><PropertyNames>accessRights</PropertyNames><PropertyNames>scanRate</PropertyNames></Browse></soap:Body></soap:Envelope>";
//    char request[256]="<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Katrin/Temperature/Complex\"><Item ItemName=\"All\"/></ItemList></Read>";
//    char request[256]="<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Examples/MultiRandom/Complex\"><Item ItemName=\"Item1\"/></ItemList></Read>";
//    char request[256]="<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Examples/MultiRandom/Integer\"><Item ItemName=\"Item1\"/></ItemList></Read>";
    
    struct curl_httpost *xml_post=NULL;
    struct curl_httpost *last_post=NULL;

    struct curl_slist* responseHeaders = NULL;
    
    
    thefile = fopen("output.xml", "w");
    
//    curl_easy_setopt(curl, CURLOPT_URL, "http://ipekatrin1.ka.fzk.de:81/");
//    curl_easy_setopt(curl, CURLOPT_URL, "http://ipepc47.ka.fzk.de/opc/debug.php");
//    curl_easy_setopt(curl, CURLOPT_URL, "http://localhost/opc/FZK.opc");
    curl_easy_setopt(curl, CURLOPT_URL, "http://ipechilinga1.ka.fzk.de/opc/FZK.opc");
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, request);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writefunc);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, thefile);


    responseHeaders = curl_slist_append(responseHeaders, "Content-Type: text/xml; charset=UTF-8");
    curl_easy_setopt(curl, CURLOPT_HTTPHEADER, responseHeaders);

    dime = 0;
    
    gettimeofday(&tm1,NULL);
    res = curl_easy_perform(curl);
    gettimeofday(&tm2,NULL);

    time1 = 1.*((tm2.tv_sec - tm1.tv_sec)*1000000 + tm2.tv_usec - tm1.tv_usec)/1000;
    
    curl_easy_getinfo(curl, CURLINFO_TOTAL_TIME, &time2);
    curl_easy_getinfo(curl, CURLINFO_CONNECT_TIME, &time3);
    
    
    fclose(thefile);

    if (dime<-1) return;
    
    printf("\n");
    printf("Connect: %.3lfms, ", time3*1000);
    printf("Request: %.3lfms, ", time2*1000);

    
    doc = xmlReadFile("output.xml", NULL, 0);
    node=xmlDocGetRootElement(doc)->children;
    rcvtime=dsXmlGetPropString(node,"RcvTime",NULL);
    replytime=dsXmlGetPropString(node,"ReplyTime",NULL);
    dsTimeSetDateTime(&otime1, rcvtime);
    dsTimeSetDateTime(&otime2, replytime);
    dsTimeCalcDuration(&oduration, &otime1, &otime2);
    xmlFreeDoc(doc);
    duration = 1000.*oduration.s + 1.*oduration.us/1000;
    printf("Internal: %.3lfms\n", duration);
    
    if (duration<smin) smin=duration;
    if (duration>smax) smax=duration;
    smid = (smid*iters + duration)/(iters+1);

    if (time1<rmin) rmin=time1;
    if (time1>rmax) rmax=time1;
    rmid = (rmid*iters + time1)/(iters+1);
    
    printf("Internal: %3.3lf(%.3lf,%.3lf)ms, iter: %lu\n",smid,smin,smax,iters);
    printf("Request : %3.3lf(%.3lf,%.3lf)ms, iter: %lu\n",rmid,rmin,rmax,iters);
    iters++;
    printf("\n");
}

int main(int argc, char *argv[]) {
    unsigned long iters = 1;
    
    
    if (argc>=2) {
	iters = atol(argv[1]);
	if (!iters) iters=-1;
    }

    curl_global_init(CURL_GLOBAL_ALL);
    curl=curl_easy_init();
    
    for (;iters>0;iters--) {
	mainloop();
//	sleep(1);
    }

    curl_easy_cleanup(curl);
}
