#define _DS_INCLUDE_XML_HEADERS

#include <stdio.h>
#include <stdint.h>
#include <curl/curl.h>

#include <dstime.h>
#include <dsxml.h>
#include "dime2.h"

#define MAX_THREADS 10

unsigned long iters = 1;

int mainloop(CURL *curl, const char *request) {
    CURLcode res;
    FILE *thefile;
    xmlDocPtr doc;
    xmlNodePtr node;
    double time1, time2, time3, duration;
    const char *rcvtime, *replytime;
    struct DSTimeT otime1, otime2;
    struct DSDurationT oduration;
    struct timeval tm1, tm2, tm3;
    struct dime_data dd;
    
    struct curl_httpost *xml_post=NULL;
    struct curl_httpost *last_post=NULL;

    struct curl_slist* responseHeaders = NULL;
    
    
//    curl_easy_setopt(curl, CURLOPT_URL, "http://ipekatrin1.ka.fzk.de:81/");
//    curl_easy_setopt(curl, CURLOPT_URL, "http://ipepc47.ka.fzk.de/opc/debug.php");
//    curl_easy_setopt(curl, CURLOPT_URL, "http://localhost/opc/FZK.opc");
//    curl_easy_setopt(curl, CURLOPT_URL, "http://ipepc47.ka.fzk.de/opc/FZK.opc");
    curl_easy_setopt(curl, CURLOPT_URL, "http://ipechilinga1.ka.fzk.de/opc/FZK.opc");
    curl_easy_setopt(curl, CURLOPT_POSTFIELDS, request);
    curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writefunc);
    curl_easy_setopt(curl, CURLOPT_WRITEDATA, &dd);


    responseHeaders = curl_slist_append(responseHeaders, "Content-Type: text/xml; charset=UTF-8");
    curl_easy_setopt(curl, CURLOPT_HTTPHEADER, responseHeaders);

    dd.dime = 0;
    dd.name = NULL;
    dd.namepos = 0;
    dd.buffered = 0;
    dd.remains = 0;
    dd.remainspad = 0;
    dd.skip = 0;
    dd.optionslength = 0;
    dd.idlength = 0;
    dd.typelength = 0;
    dd.moredata = 0;

    res = curl_easy_perform(curl);
}


void *tf(void *data) {
    unsigned long i;
    CURL *curl;
    char request[256];
    
    sprintf(request, "<Read xmlns=\"http://opcfoundation.org/webservices/XMLDA/1.0/\"><ItemList ItemPath=\"/Examples/MultiRandom/Complex\"><Item ItemName=\"Item%i\"/></ItemList></Read>", (*(int*)data)+1);

    curl=curl_easy_init();

    for (i=0;i<iters;i++) {
	mainloop(curl, request);
//	sleep(1);
    }

    curl_easy_cleanup(curl);

    return NULL;
}


int main(int argc, char *argv[]) {
    pthread_t *trd;
    unsigned long i, threads = 1, executed = 0;
    void *res;

    double time1;
    struct timeval tm1, tm2;

    if (argc>=2) {
	threads = atol(argv[1]);
	if (!threads) threads=1;
	
	trd = (pthread_t*)malloc(threads*sizeof(pthread_t));
	if (!trd) {
	    printf("Unable allocate memory");
	    exit(0);
	}
    } else {
	printf("Usage: %s <threads> [iters]\n",argv[0]);
	exit(0);
    }
    
    if (argc>=3) {
	iters = atol(argv[2]);
	if (!iters) iters=-1;
    }

    curl_global_init(CURL_GLOBAL_ALL);

    gettimeofday(&tm1,NULL);

    for (i=0;i<threads;i++)
	if (!pthread_create(trd+i,NULL,tf,(void*)i)) executed++;

    for (i=0;i<threads;i++) {
	pthread_join(trd[i], &res);
    }
	
    gettimeofday(&tm2,NULL);

    time1 = 1.*((tm2.tv_sec - tm1.tv_sec)*1000000 + tm2.tv_usec - tm1.tv_usec)/1000;


    printf("Total time: %.2lfms (%lu childs, %lu iters)\n",time1, executed, iters);
    printf("Request time: %.2lfms\n", time1 / executed / iters);


    free(trd);
}


