#ifndef _MODULE_RANDOM_H
#define _MODULE_RANDOM_H

#include <dsplugin.h>
#include <dsallocator.h>

#include <opc.h>
#include <opcitem.h>
#include <dsbinarytype.h>
#include <dsopcbinarydictionary.h>


#define SIZE 65536 /* Change in dictionary!!! */
#define STEPS 8
#define SKIP 5
#define CLIENTS 3

/*
#define INUM 1
#define DNUM 0
#define CNUM 0
*/
#define INUM 1
#define DNUM 20
#define CNUM 1024

//#define FAST_DATA_MANAGER
//#define FAST_DATA_MANAGER_XML
#define LEGACY_DATA_MANAGER
//#define LEGACY_DATA_MANAGER_BINARY
//#define LEGACY_DATA_MANAGER_DATABUFFER


struct _random_simple_t {
    short int i16;
    unsigned long int ui32;
    double dbl;
};

// rewrite truth uint32
struct _random_complex_t {
    short int i16;
    unsigned long int ui32;
    double dbl;
    double array[SIZE];
};

struct _random {
    unsigned char items;
    unsigned long *item;
};

typedef struct RandomContextT *RandomContext;

struct RandomContextT {
    DSPluginContext pctx;
    OPCItemContext ictx_int[INUM];
    OPCItemContext ictx_double[DNUM];
    OPCItemContext ictx_complex[CNUM];
    DSBinaryType inttype;
    DSBinaryType doubletype;
    DSBinaryType complextype;
    DSOPCBinaryDictionaryContext dict;
#ifdef FAST_DATA_MANAGER
    DSDataManagerFastContext dm;
#endif
#ifdef LEGACY_DATA_MANAGER
    DSDataManagerRepContext dm;
#endif
    
    DSAllocatorContext allocator;
    struct _random data;
};

RandomContext randomCreateContext();
int randomInitContext(RandomContext ctx, DSPluginContext pctx, OPCContext sctx);
int randomRun(RandomContext ctx);
void randomFreeContext(RandomContext ctx);
void randomDestroyContext(RandomContext ctx);


struct DSPluginInfoContextT info = {
    "random",
    "1.0",
    (DSPluginCreateFunction)&randomCreateContext,
    (DSPluginInitFunction)&randomInitContext,
    (DSPluginStepFunction)&randomRun,
    (DSPluginFreeFunction)&randomFreeContext,
    (DSPluginDestroyFunction)&randomDestroyContext
};

#endif /* _MODULE_RANDOM_H */
