#ifndef _DS_DATA_CONVERTER_H
#define _DS_DATA_CONVERTER_H

#include <dsmalloc.h>
#include <dsmodule.h>
#include <dsrepresentation.h>
#include <dsrepresentationbinary.h>

#define DS_DATA_CONVERTER_OPCXML_FORM_NATIVE 0
#define DS_DATA_CONVERTER_OPCXML_FORM_OPCXML 1

struct DSDataConverterContextT {
    DSModuleS module;

    DSRepresentationInstance *representation;

    DSDataChunkForm supported_representations;
    DSDataChunkForm allocated_representations;

};

typedef struct DSDataConverterContextT DSDataConverterContextS;
typedef struct DSDataConverterContextT *DSDataConverterContext;


DSDataConverterContext dsDataConverterCreateContext(DSMallocContext mctx);
int dsDataConverterInitContext(DSDataConverterContext ctx, size_t representations);
void dsDataConverterFreeContext(DSDataConverterContext ctx);
void dsDataConverterDestroyContext(DSDataConverterContext ctx);

DSDataConverterContext dsDataConverterCreateOPCXML(DSMallocContext mctx, DSBinaryType type);

DSRepresentationInstance dsDataConverterGetRepresentation(DSDataConverterContext ctx, DSDataChunkForm repid);
int dsDataConverterRegisterRepresentationInstance(DSDataConverterContext ctx, DSRepresentationInstance base, DSRepresentationInstance rep);
DSRepresentationInstance dsDataConverterRegisterRepresentation(DSDataConverterContext ctx, DSRepresentationInstance base, DSRepresentation rep, DSRepresentationOptions options);
DSRepresentationInstance dsDataConverterRegisterBinaryRepresentation(DSDataConverterContext ctx, DSRepresentationInstance base, DSBinaryFormat format, DSBinaryType type, DSAllocatorContext allocator);
DSRepresentationInstance dsDataConverterRegisterNativeRepresentation(DSDataConverterContext ctx, DSBinaryType type, DSAllocatorContext allocator);
DSRepresentationInstance dsDataConverterRegisterOPCXMLRepresentation(DSDataConverterContext ctx, DSRepresentationInstance base, DSBinaryType type);


int dsDataConverterConvert(DSDataConverterContext ctx, DSRepresentationInstance rep, DSDataChunkContext chunk);
int dsDataConverterConvertData(DSDataConverterContext ctx, DSRepresentationInstance to, DSData dst, DSRepresentationInstance from, DSDataConst src);

/* This function is considerably limited. Only simple types, and it should not
be mixed with other Convert calls */
int dsDataConverterConvertBinaryData(DSDataConverterContext ctx, DSRepresentationInstance to, DSData dst, DSRepresentationInstance from, DSDataConst src, DSBinaryType type);

#endif /* _DS_DATA_CONVERTER_H */
