#ifndef _DS_DATA_REPRESENTATION_H
#define _DS_DATA_REPRESENTATION_H

#include <dsallocator.h>
#include <dsbinaryformat.h>

#include <dsrepresentation.h>

/*
    allocator would be freed on exit, format & type - not 
*/
struct DSRepresentationBinaryOptionsT {
    DSRepresentationOptionsS options;
    
    DSAllocatorContext allocator;
    DSBinaryFormat format;
    DSBinaryType type;

    DSBinaryFormatInstanceOptions format_options;
};
typedef struct DSRepresentationBinaryOptionsT *DSRepresentationBinaryOptions;
typedef struct DSRepresentationBinaryOptionsT DSRepresentationBinaryOptionsS;

DSRepresentationBinaryOptions dsRepresentationBinaryGetDefaultOptions(DSBinaryFormat format, DSBinaryType type);
int dsRepresentationBinaryInitDefaultOptions(DSRepresentationBinaryOptions options, DSBinaryFormat format, DSBinaryType type);
void dsRepresentationBinaryDestroyOptions(DSRepresentationBinaryOptions options);
int dsRepresentationBinaryOptionsSetAllocator(DSRepresentationBinaryOptions options, DSAllocatorContext allocator);
int dsRepresentationBinaryOptionsSetFormatOptions(DSRepresentationBinaryOptions options, DSBinaryFormatInstanceOptions format_options);

struct DSRepresentationBinaryContextT {
    DSLockContext lock;
    DSLockContext allocator_lock;
    
    DSAllocatorContext allocator;
    DSBinaryFormatInstance format;
    DSBinaryType type;

    unsigned char grabed_allocator;
};
typedef struct DSRepresentationBinaryContextT DSRepresentationBinaryContextS;
typedef struct DSRepresentationBinaryContextT *DSRepresentationBinaryContext;

DSAllocatorContext dsRepresentationBinaryGetAllocator(DSRepresentationInstance instance);
int dsRepresentationBinaryReturnAllocator(DSRepresentationInstance instance, DSAllocatorContext allocator);

DSRepresentation dsRepresentationBinary();

DSRepresentationInstance dsRepresentationBinaryCreateNativeInstance(DSMallocContext mctx, DSBinaryType type, DSAllocatorContext allocator);
DSRepresentationInstance dsRepresentationBinaryCreateOPCXMLInstance(DSMallocContext mctx, DSBinaryType type);

int dsRepresentationBinaryPushAllocation(DSRepresentationInstance ctx, DSDataChunkContext chunk, DSAllocation allocation);

#endif /* _DS_DATA_REPRESENTATION_H */
