#ifndef _DS_BINARY_FORMAT_POOL_H
#define _DS_BINARY_FORMAT_POOL_H

#include <dsmalloc.h>
#include <dshashtable.h>
#include <dsbinaryformat.h>

typedef struct DSBinaryFormatPoolContextT *DSBinaryFormatPoolContext;

struct DSBinaryFormatPoolContextT {
    DSMallocContext malloc;
    DSBinaryFormat native_format;
    DSBinaryFormat binary_format;
    DSBinaryFormat opcxml_format;
    DSHashTable formats;
    unsigned int max_formats;
    unsigned int registered_formats;
};

DSBinaryFormatPoolContext dsBinaryFormatPoolCreateContext(DSMallocContext mctx);
int dsBinaryFormatPoolInitContext(DSBinaryFormatPoolContext ctx, size_t scaling);
void dsBinaryFormatPoolFreeContext(DSBinaryFormatPoolContext ctx);
void dsBinaryFormatPoolDestroyContext(DSBinaryFormatPoolContext ctx);

int dsBinaryFormatPoolRegisterFormat(DSBinaryFormatPoolContext ctx, DSBinaryFormat fctx);
/* ToDo: int dsBinaryFormatPoolRemoveFormat(Ref,Unref CreateContext and RegisterFormat ref)? */
DSBinaryFormat dsBinaryFormatPoolFindFormat(DSBinaryFormatPoolContext ctx, const char *format);

#endif /* _DS_BINARY_FORMAT_POOL_H */

