#ifndef _DS_CHUNK_POOL
#define _DS_CHUNK_POOL

#include <dsmalloc.h>
#include <dslock.h>
#include <dsdatachunk.h>

typedef struct DSChunkPoolContextT *DSChunkPoolContext;

struct DSChunkPoolContextT {
    DSMallocContext malloc;
    DSLockContext lock;

    DSDataHandler defhandler;

    unsigned char bins;    
    DSDataChunkContext *first_chunk;
    DSDataChunkContext *last_chunk;
};

DSChunkPoolContext dsChunkPoolCreateContext(DSMallocContext mctx);
int dsChunkPoolInitContext(DSChunkPoolContext ctx, unsigned char bins);
void dsChunkPoolFreeContext(DSChunkPoolContext ctx);
void dsChunkPoolDestroyContext(DSChunkPoolContext ctx);

int dsChunkPoolSetDefaultDataHandler(DSChunkPoolContext ctx, DSDataHandler defhandler);

DSDataChunkContext dsChunkPoolGetChunk(DSChunkPoolContext ctx, DSDataHandler defhandler, unsigned int forms);
void dsChunkPoolReturnChunk(DSChunkPoolContext ctx, DSDataChunkContext chunk);

#endif /* _DS_CHUNK_POOL */
