#ifndef _DS_HOLDER_H
#define _DS_HOLDER_H

#include <dslock.h>
#include <dscondition.h>
#include <dsmalloc.h>
#include <dsdoublehash.h>
#include <dstime.h>

#include <dsholderbucket.h>

typedef struct DSHolderContextT *DSHolderContext;

struct DSHolderContextT {
    DSMallocContext malloc;
    DSDoubleHashContext double_hash;
    DSLockContext lock;
    DSConditionContext cond;
    
    unsigned long max_size;
    DSDurationS timeout;
};

DSHolderContext dsHolderCreateContext(DSMallocContext mctx);
int dsHolderInitContext(DSHolderContext ctx, unsigned long size);
void dsHolderFreeContext(DSHolderContext ctx);
void dsHolderDestroyContext(DSHolderContext ctx);
void dsHolderMantain(DSHolderContext ctx);

void dsHolderSetMaxSize(DSHolderContext ctx, unsigned long max_size);
void dsHolderSetTimeout(DSHolderContext ctx, DSDuration timeout);

unsigned long dsHolderPut(DSHolderContext ctx, DSHolderBucketContext bucket);
DSHolderBucketContext dsHolderGet(DSHolderContext ctx, unsigned long pos, unsigned long magic, unsigned long secret);
const void* dsHolderGetLink(DSHolderContext ctx, unsigned long pos, unsigned long magic, unsigned long secret);
void dsHolderReturnLink(DSHolderContext ctx, unsigned long pos);

#endif /* _DS_HOLDER_H */
