#ifndef _DS_HOLDER_BUCKET_H
#define _DS_HOLDER_BUCKET_H

#include <dslock.h>
#include <dsmalloc.h>

#include <dstime.h>

struct DSHolderBucketContextT {
    void *data;
    DSTimeS destruction_time;
    DSDurationS step_time;
    DSDestroyContextFunction destructor;
    DSMallocContext malloc;
    DSLockContext lock;
    unsigned long magic;
    unsigned long secret;
};

typedef struct DSHolderBucketContextT *DSHolderBucketContext;

DSHolderBucketContext dsHolderBucketInitContext(DSMallocContext mctx, void *ptr, DSDuration lifetime, DSDuration steptime, DSDestroyContextFunction destructor);
void dsHolderBucketDestroyContext(DSHolderBucketContext ctx);

void dsHolderBucketLock(DSHolderBucketContext ctx);
void dsHolderBucketUnlock(DSHolderBucketContext ctx);
void dsHolderBucketRestartTimer(DSHolderBucketContext ctx);

int dsHolderBucketMantain(DSHolderBucketContext ctx, void *attr);

int dsHolderBucketSetNumbers(DSHolderBucketContext ctx, unsigned long magic);
int dsHolderBucketCheckMagicNumber(DSHolderBucketContext ctx, unsigned long magic);
int dsHolderBucketCheckSecretNumber(DSHolderBucketContext ctx, unsigned long secret);

#define DS_HOLDER_BUCKET_MAGIC_REQUEST_BROWSE 1



#endif /* _DS_HOLDER_BUCKET_H */
