#include <dslib.h>

#include <dsassert.h>
#include <dsdebug.h>

#include <dsdatamanager.h>
#include <dsdatamanageruserize.h>

/* DS: Very important
We are assuming in all Data Handlers, what Copy/Pipe/Destroy do not need to
modify any FormatInstance data structures during processing, otherwise we
should init new FormatInstance instead of using actual one.
*/

int dsDataManagerUserize(DSData user_data, DSDataConst data, DSDataManagerUserizeOptions options) {
    int err;
    
    ds_assert_param(user_data);
    ds_assert_param(data);
    
    printf("%p %p %p\n", user_data, data, data->handler);
    printf("%u %u %u %u\n", data->type, data->user_type, data->handler->type, data->handler->user_type);
    if ((data->handler)&&(DS_DATA_MANAGER_HANDLER(data->handler)->GetUserData)) {
	puts("USERIZING");
	err = DS_DATA_MANAGER_HANDLER(data->handler)->GetUserData(user_data, data, options);
	if (err != DS_ERR_NOTAPPLICABLE) return err;
    }

//    return dsDataCopyContent(user_data, data);
    return dsDataSetReference(user_data, (DSData)data);
}

int dsDataManagerUserizeOptionsInitNative(DSDataManagerUserizeOptions opts) {
    ds_assert_param(opts);
    
    memset(opts, 0, sizeof(DSDataManagerUserizeOptionsS));
    opts->representation = DS_DATA_MANAGER_FORM_NATIVE;
    return 0;
}

int dsDataManagerUserizeOptionsInitOPCXML(DSDataManagerUserizeOptions opts) {
    ds_assert_param(opts);
    
    memset(opts, 0, sizeof(DSDataManagerUserizeOptionsS));
    opts->representation = DS_DATA_MANAGER_FORM_OPCXML;
    return 0;
}

int dsDataManagerUserizeOptionsSetLocale(DSDataManagerUserizeOptions opts, const char *locale) {
    ds_assert_param(opts);
    
    opts->locale = locale;
    return 0;
}

int dsDataManagerUserizeOptionsSetCopier(DSDataManagerUserizeOptions opts, DSDataCopier copier) {
    ds_assert_param(opts);
    
    opts->copier = copier;
    return 0;
}
