#ifndef _DS_DATA_MANAGER_USERIZE_H
#define _DS_DATA_MANAGER_USERIZE_H

#include <dsdata.h>
#include <dsdatahandler.h>

enum DSDataManagerUserizeFlagsT {
    DS_DATA_MANAGER_USERIZE_FLAG_XMLNODE_BEAR = 1
};

typedef enum DSDataManagerUserizeFlagsT DSDataManagerUserizeFlags;

struct DSDataManagerUserizeOptionsT {
    DSDataManagerUserizeFlags flags;
    DSDataCopier copier;

    const char *locale;
    const void *security;
    const char *representation;
};
typedef struct DSDataManagerUserizeOptionsT DSDataManagerUserizeOptionsS;
typedef struct DSDataManagerUserizeOptionsT *DSDataManagerUserizeOptions;

typedef int (*DSDataManagerGetUserDataFunction)(DSData user_data, DSDataConst data, DSDataManagerUserizeOptions options);

int dsDataManagerUserize(DSData user_data, DSDataConst data, DSDataManagerUserizeOptions options);

#define DS_DATA_MANAGER_HANDLER(ctx) ((DSDataManagerDataHandler)ctx)

struct DSDataManagerDataHandlerT {
    DSDataHandlerS handler;

    void *userizer;
    DSDataManagerGetUserDataFunction GetUserData; 
};
typedef struct DSDataManagerDataHandlerT *DSDataManagerDataHandler;
typedef struct DSDataManagerDataHandlerT DSDataManagerDataHandlerS;

enum DSDataManagerDataHandlerTypeT {
    DS_DATA_MANAGER_DATAHANDLER_TYPE_MANAGERFAST = 1,
    DS_DATA_MANAGER_DATAHANDLER_TYPE_REPRESENTATION
};
typedef enum DSDataManagerDataHandlerTypeT DSDataManagerDataHandlerType;

int dsDataManagerUserizeOptionsInitNative(DSDataManagerUserizeOptions opts);
int dsDataManagerUserizeOptionsInitOPCXML(DSDataManagerUserizeOptions opts);
int dsDataManagerUserizeOptionsSetLocale(DSDataManagerUserizeOptions opts, const char *locale);
int dsDataManagerUserizeOptionsSetCopier(DSDataManagerUserizeOptions opts, DSDataCopier copier);

#endif /* _DS_DATA_MANAGER_USERIZE_H */
