#ifndef _DS_OPCBINARY_H
#define _DS_OPCBINARY_H

#include <dsxml.h>
#include <dsmalloc.h>
#include <dslock.h>

typedef struct DSOPCBinaryContextT *DSOPCBinaryContext;

#include <dsopcbinarydictionary.h>

/*
    Namespace name is stored in ctx->schema_rep->targetNamespace
*/
struct DSOPCBinaryContextT {
    DSMallocContext malloc;
    DSLockContext lock;
    
    char *dictdir;
    size_t dictdir_chars;
    
    xmlSchemaPtr schema_rep;
};

DSOPCBinaryContext dsOPCBinaryCreateContext(DSMallocContext mctx);
int dsOPCBinaryInitContext(DSOPCBinaryContext ctx, const char *schema, const char *dictdir);
void dsOPCBinaryFreeContext(DSOPCBinaryContext ctx);
void dsOPCBinaryDestroyContext(DSOPCBinaryContext ctx);

int dsOPCBinaryValidateXML(DSOPCBinaryContext ctx, xmlDocPtr doc);
int dsOPCBinaryValidateDictionary(DSOPCBinaryContext ctx, DSOPCBinaryDictionaryContext dctx);
DSOPCBinaryDictionaryContext dsOPCBinaryCreateDictionaryFromMemory(DSOPCBinaryContext ctx, const char *xml, unsigned long length);
DSOPCBinaryDictionaryContext dsOPCBinaryCreateDictionary(DSOPCBinaryContext ctx, const char *dictionary);


#endif /* _DS_OPCBINARY_H */
