#ifndef _DS_BINARY_TYPE_H
#define _DS_BINARY_TYPE_H

#include <dslib.h>
#include <dstreenode.h>

typedef enum DSBinaryTypeOptionsT DSBinaryTypeOptions;
typedef enum DSBinaryTypeClassT DSBinaryTypeClass;
typedef struct DSBinaryTypeT *DSBinaryType;

enum DSBinaryTypeClassT {
    DS_BINARY_TYPE_CLASS_COMPLEX = 0,
    DS_BINARY_TYPE_CLASS_ALIGN,
    DS_BINARY_TYPE_CLASS_INTEGER,
    DS_BINARY_TYPE_CLASS_FLOAT,
    DS_BINARY_TYPE_CLASS_STRING
};

/*
#define DS_BINARY_TYPE_CLASS_STRING		1
#define DS_BINARY_TYPE_CLASS_STRINGLIST		2
#define DS_BINARY_TYPE_CLASS_URL		3
#define DS_BINARY_TYPE_CLASS_QNAME		4
#define DS_BINARY_TYPE_CLASS_BASE64		5
#define DS_BINARY_TYPE_CLASS_ENUMERATION	6
#define DS_BINARY_TYPE_CLASS_DATETIME		7
#define DS_BINARY_TYPE_CLASS_DOUBLE		8
#define DS_BINARY_TYPE_CLASS_UNSIGNED		9
#define DS_BINARY_TYPE_CLASS_INT		10
#define DS_BINARY_TYPE_CLASS_BOOLEAN		11
*/


enum DSBinaryTypeOptionsT {
    DS_BINARY_TYPE_CLASS_OPTION_MASTER = 1
};

#define DS_BINARY_TYPE(ctx) ((DSBinaryType)ctx)
struct DSBinaryTypeT {
    struct DSTreeComplexNodeContextT node;
    DSBinaryTypeClass type;
    DSBinaryTypeOptions options;

    unsigned long element_count;
    char *terminator;			/* hexBinary */
    DSBinaryType element_count_ref;
    
    unsigned long size;			/* 0 - variable */

    unsigned char align;
    unsigned char is_pointer;
};


#include <dsbinarytypesimple.h>
#include <dsbinarytypecomplex.h>

DSBinaryType dsBinaryTypeCreate(DSMallocContext mctx);
int dsBinaryTypeInit(DSBinaryType ctx, DSBinaryTypeClass type, DSDestroyContextFunction destructor);
void dsBinaryTypeFree(DSBinaryType ctx);
void dsBinaryTypeDestroy(DSBinaryType ctx);

void dsBinaryTypeSetMaster(DSBinaryType ctx);
void dsBinaryTypeResetMaster(DSBinaryType ctx);

void dsBinaryTypeSetElementCount(DSBinaryType ctx, unsigned long element_count);
void dsBinaryTypeSetElementCountRef(DSBinaryType ctx, DSBinaryType ref);
void dsBinaryTypeSetTerminator(DSBinaryType ctx, const char *terminator);
void dsBinaryTypeSetExternal(DSBinaryType ctx);
void dsBinaryTypeSetAlignment(DSBinaryType ctx, unsigned char align);

int dsBinaryTypePush(DSBinaryType ctx, DSBinaryType child);


#endif /* _DS_BINARY_TYPE_H */
