#ifndef _DS_BINARY_TYPE_STANDARD_H
#define _DS_BINARY_TYPE_STANDARD_H

#include <dsbinarytypesimple.h>

extern DSBinaryTypeInteger ds_binary_type_int_8t;
extern DSBinaryTypeInteger ds_binary_type_int_16t;
extern DSBinaryTypeInteger ds_binary_type_int_32t;
extern DSBinaryTypeInteger ds_binary_type_int_64t;

extern DSBinaryTypeInteger ds_binary_type_uint_8t;
extern DSBinaryTypeInteger ds_binary_type_uint_16t;
extern DSBinaryTypeInteger ds_binary_type_uint_32t;
extern DSBinaryTypeInteger ds_binary_type_uint_64t;

extern DSBinaryTypeFloat ds_binary_type_float;
extern DSBinaryTypeFloat ds_binary_type_double;

extern DSBinaryTypeString ds_binary_type_utf8_string;

int dsBinaryTypeStandardInit();
void dsBinaryTypeStandardDestroy();


enum DSBinaryTypeStandardT {
    DS_BINARY_TYPE_STANDARD_COMPLEX = 0,
    DS_BINARY_TYPE_STANDARD_ENUMERATION,
    DS_BINARY_TYPE_STANDARD_UNSIGNED_CHAR,
    DS_BINARY_TYPE_STANDARD_UNSIGNED_SHORT,
    DS_BINARY_TYPE_STANDARD_UNSIGNED,
    DS_BINARY_TYPE_STANDARD_UNSIGNED_LONG,
    DS_BINARY_TYPE_STANDARD_CHAR,
    DS_BINARY_TYPE_STANDARD_SHORT,
    DS_BINARY_TYPE_STANDARD_INT,
    DS_BINARY_TYPE_STANDARD_LONG,
    DS_BINARY_TYPE_STANDARD_FLOAT,
    DS_BINARY_TYPE_STANDARD_DOUBLE,
    DS_BINARY_TYPE_STANDARD_STRING,
    DS_BINARY_TYPE_STANDARD_STRINGLIST,
    DS_BINARY_TYPE_STANDARD_XML,
    DS_BINARY_TYPE_STANDARD_QNAME,
    DS_BINARY_TYPE_STANDARD_DATETIME,
    DS_BINARY_TYPE_STANDARD_DATE,
    DS_BINARY_TYPE_STANDARD_TIME
};
typedef enum DSBinaryTypeStandardT DSBinaryTypeStandard;

DSBinaryType dsBinaryTypeStandardCreate(DSMallocContext mctx, DSBinaryTypeStandard datatype, const void *attr);
DSBinaryTypeInteger dsBinaryTypeStandardCreateEnumerationFromArray(DSMallocContext mctx, const char **array, unsigned char copy_strings);

#endif /* _DS_BINARY_TYPE_STANDARD_H */
