#ifndef _DS_BINARY_CONFIGURATION_H
#define _DS_BINARY_CONFIGURATION_H

#include <dsmalloc.h>
#include <dslib.h>

#define ENDIANESS_LITTLE_ENDIAN 0
#define ENDIANESS_BIG_ENDIAN 1
#define ENDIANESS_MIXED_ENDIAN 2

#define FLOAT_FORMAT_IEEE 0

#define ALIGN_STRUCT_MAX 0
#define ALIGN_STRUCT_FIRST 1

typedef struct DSBinaryConfigurationContextT *DSBinaryConfigurationContext;
extern DSBinaryConfigurationContext ds_binary_configuration;

struct DSBinaryConfigurationContextT {
    DSMallocContext malloc;
    unsigned char pointer_size;
    unsigned char float_size;
    unsigned char double_size;
    unsigned char long_double_size;
    unsigned char enum_size;
    unsigned char endianess;
    unsigned char float_format;
    unsigned char float_endianess;
    
    unsigned short align_allocation; /* Should be multiple of any other alignments */
    unsigned short align_pointer;
    unsigned short align_int8;
    unsigned short align_int16;
    unsigned short align_int32;
    unsigned short align_int64;
    unsigned short align_enum;
    unsigned short align_float;
    unsigned short align_double;
    unsigned short align_long_double;
    unsigned short align_struct_min;
    unsigned short align_struct_max;
    unsigned short align_struct_algo;
};

int dsBinaryConfigurationInit();
void dsBinaryConfigurationDestroy();

DSBinaryConfigurationContext dsBinaryConfigurationCreateContext(DSMallocContext mctx);
int dsBinaryConfigurationInitContext(DSBinaryConfigurationContext ctx);
void dsBinaryConfigurationFreeContext(DSBinaryConfigurationContext ctx);
void dsBinaryConfigurationDestroyContext(DSBinaryConfigurationContext ctx);

#endif /* _DS_BINARY_CONFIGURATION_H */
