#include <dslib.h>

#include <dsdebug.h>
#include <dslocale.h>
#include <dserror.h>
#include <dsxml.h>
#include <dssignal.h>
#include <dsthread.h>
#include <dsconnection.h>
#include <dsconnectionserver.h>
#include <dstime.h>
#include <dsmodule.h>

int dsLibInit() {
    int err;
    
    err=dsMallocInit();
    if (!err) err=dsDebugInit();
    if (!err) err=dsLibTimeInit();
    if (!err) err=dsErrorInit();
    if (!err) err=dsModuleInit();
    if (!err) err=dsLocaleInit();
    if (!err) err=dsXmlInit();
    if (!err) err=dsBinaryConfigurationInit();
    if (!err) err=dsSignalInit();
    if (!err) err=dsThreadInit();
#ifndef DS_BUILD_PHARLAP
    if (!err) err=dsConnectionServerInit();
#endif /* ! DS_BUILD_PHARLAP */
    if (!err) err=dsConnectionInit();
    if (!err) err=dsBinaryTypeStandardInit();

    return err;
}

void dsLibFree() {
    dsBinaryTypeStandardDestroy();
    dsConnectionDestroy();
#ifndef DS_BUILD_PHARLAP
    dsConnectionServerDestroy();
#endif /* ! DS_BUILD_PHARLAP */
    dsThreadDestroy();
    dsSignalDestroy();
    dsBinaryConfigurationDestroy();
    dsXmlDestroy();
    dsLocaleDestroy();
    dsModuleDestroy();
    dsErrorDestroy();
    dsLibTimeFree();
    dsDebugDestroy();
    dsMallocDestroy();
}
