#define _DS_INCLUDE_XML_HEADERS

#include <stdio.h>

#include <dsconfig.h>

#define BufferSize 16384

main() {
    int err;
    size_t readed;
    char *buf[BufferSize+1];
    DSConfigContext cfg;

    xmlNodePtr node, node1, node2;
    size_t size;
    char *mem;
    
    const char *str;
    int num;
    
    dsLibInit();
    
    cfg = dsConfigCreateContext(NULL);

    if (cfg) err = dsConfigInitContext(cfg, "config.xml");
    else err = DS_ERR_MEM;
    
    if (!err) err = dsConfigLoad(cfg);
    
    if (!err) err = dsConfigEnableAutosetDefaults(cfg);
    
    if (!err) {
	node1 = dsConfigGetConfig(cfg, NULL, "/Config/SubConfig[@layer = 1]");

	if (node1) {
	    node = node1;
	    
	    str = dsConfigGetString(cfg, "s1", node, "String1");
	    printf("1: %s\n", str?str:"");
	    str = dsConfigGetString(cfg, "s2", node, "String2");
	    printf("2: %s\n", str?str:"");
	    str = dsConfigGetString(cfg, "a2", node, "String2/@attr");
	    printf("3: %s\n", str?str:"");
	    str = dsConfigGetString(cfg, "s3", node, "String3[@layer = 1 and @sensor=2]");
	    printf("4: %s\n", str?str:"");
	} 
	if (node1) dsConfigReturnConfig(cfg, node1);

	node2 = dsConfigGetConfig(cfg, NULL, "/Config/SubConfig[@layer='2']");
	if (node2) {
	    node = node2;
	    
	    num = dsConfigGetInt(cfg, 5, node, "Int1[@layer= '1' and @sensor='2']");
	    printf("1: %i\n", num);
	    num = dsConfigGetPropInt(cfg, node, "String1", -99);
	    printf("2: %i\n", num);
	}	    
	if (node2) dsConfigReturnConfig(cfg, node2);

	node1 = dsConfigGetConfig(cfg, NULL, "/Config/SubConfig[@layer = 1]");
	if (node1) dsConfigSetString(cfg, "s1 revised", node1, "String1");
	if (node1) dsConfigReturnConfig(cfg, node1);
	    
	    
	dsConfigDumpMemory(cfg, &mem, &size);
	puts(mem);
	free(mem);
	    
	dsConfigSaveTo(cfg, "newconfig.xml");
    }
    
    if (cfg) dsConfigDestroyContext(cfg);
    
    dsLibFree();
}
