#ifndef _DSLIB_CONFIG_H
#define _DSLIB_CONFIG_H

#undef HAVE_STRING_H
#undef HAVE_STDINT_H
#undef HAVE_UNISTD_H
#undef HAVE_SYS_TYPES_H
#undef HAVE_SYS_STAT_H
#undef HAVE_SYS_SOCKET_H
#undef HAVE_SYS_TIME_H

#undef DS_TRACK_LOCKS
#undef DS_TRACK_MEMORY
#undef DS_TRACK_MODULES
//#define DS_TRACK_LOCKS
//#define DS_TRACK_MEMORY
//#define DS_TRACK_MODULES

#ifdef DS_TRACK_LOCKS
# define DS_TRACK_LOCKS_TRACK_BY_DEFAULT 1
#endif /* DS_TRACK_LOCKS */

#ifdef DS_TRACK_MEMORY
# define DS_TRACK_MEMORY_TRACK_BY_DEFAULT 1
#endif /* DS_TRACK_MEMORY */

#ifdef PHARLAP
# define DS_BUILD_PHARLAP
#endif /* PHARLAP */

#ifdef _WIN32
# define DS_BUILD_WIN
# define DS_BUILD_WIN32
#endif /* _WIN32 */

#ifdef DS_BUILD_PHARLAP
# ifndef DS_BUILD_WIN32
#  error "Pharlap build on Win32 platform is not supported"
# endif /* DS_BUILD_WIN32 */
#endif /* DS_BUILD_PHARLAP */

#ifdef _WIN32
# include <dslib_windows_config.h>
#else /* UNIX, use autoconf(config.h) */
# include <dslib_unix_config.h>
# define HAVE_SOCKETS
#endif /* _WIN32 */

#ifdef TIME_WITH_SYS_TIME
# define HAVE_SYS_TIME_H			1
#endif /* TIME_WITH_SYS_TIME */

#ifdef _WIN32
# undef HAVE_SYS_SOCKET_H
# undef HAVE_NETINET_IN_H
# undef HAVE_SYS_UN_H
#endif /* _WIN32 */

#ifndef HAVE_PSELECT
# undef HAVE_PSELECT_SYSCALL
#endif /* HAVE_PSELECT */

#ifndef HAVE_SETJMP_H
/* DS: Not safe. Possible to implement with pipes. */
# define HAVE_PSELECT			1
# define HAVE_PSELECT_SYSCALL		1
#endif /* !HAVE_SETJMP_H */

#ifdef _GNU_SOURCE
# define DS_SUPPORT_RWLOCK		/* Switch on "One Write Multiple Read" Locking */
#endif /* _GNU_SOURCE */

#ifdef HAVE_ALLOCA
# ifdef HAVE_ALLOCA_H
#  include <alloca.h>
# endif /* HAVE_ALLOCA_H */
# define dsMalloca(size) alloca(size)
# define dsFreea(size)
#else /* HAVE_ALLOCA */
# define dsMalloca(size) malloc(size)
# define dsFreea(size) free(size)
#endif /* HAVE_ALLOCA */

#ifndef HAVE_STRCASECMP
# ifdef HAVE_STRICMP
#  define strcasecmp stricmp
# else /* HAVE_STRICMP */
#  define strcasecmp strcmp
# endif /* HAVE_STRICMP */
#endif /* HAVE_STRCASECMP */

#endif /* _DSLIB_CONFIG_H */
