#ifndef _DSLIB_ERROR_H
#define _DSLIB_ERROR_H

#define dsErrorModule(err,module)		((err)?((err&0xFFFF)|(module<<16)):0)
#define dsErrorGetError(err)			((err)&0xFFFF)
#define dsErrorGetModule(err)			((err)>>16)
#define dsErrorIs(err, num)			(((err)&0xFFFF)==(num))

#define dsError(err,locale) dsErrorName(dsErrorGetError(err), locale)
#define dsErrorSource(err) dsModuleName(dsErrorGetModule(err))

/* Refactoring: Eleminate all complex errors, then required do
    DS_ERR_SYSCALL_SIGACTION = (DS_ERR_SYSCALL(0x50-0xFF)|DS_ERR_SIGACTION(2nd byte)?
    all complex errors are (SimpleError 6bits) + (AffectedModule 14bits) */

#define DS_ERR					0x10
#define DS_ERR_MEM				0x11
#define DS_ERR_STACK				0x12
#define DS_ERR_NOTFOUND				0x13
#define DS_ERR_INVALID_PATH			0x14
#define DS_ERR_INVALID_FILE			0x15
#define DS_ERR_NOTIMPLEMENTED			0x16
#define DS_ERR_NOTAVAILABLE			0x17
#define DS_ERR_NOTSUPPORTED			0x18
#define DS_ERR_NOTAPPLICABLE			0x19
#define DS_ERR_INVALID_ARGUMENT			0x1A
#define DS_ERR_INVALID_OPTIONS			0x1B
#define DS_ERR_NOTINITIALIZED			0x1C
#define DS_ERR_INITIALIZED			0x1D 
#define DS_ERR_BUSY				0x1E
#define DS_ERR_TIMEOUT				0x1F
#define DS_ERR_EMPTY				0x20
#define DS_ERR_PERMISSION			0x21
#define DS_ERR_EXIST				0x22
#define DS_ERR_MULTIPLE				0x23
#define DS_ERR_TOOLONG				0x24
#define DS_ERR_INVALID_REQUEST			0x25
#define DS_ERR_INVALID_RESPONSE			0x26
#define DS_ERR_INTERNAL				0x27
#define DS_ERR_RETRY				0x28
#define DS_ERR_DISABLED				0x29
#define DS_ERR_DISABLED_ITEM			0x30
#define DS_ERR_INCOMPLETE			0x31
#define DS_ERR_CREATE				0x32

#define DS_ERR_SYSCALL_SIGACTION		0x50
#define DS_ERR_SYSCALL_SIGPROCMASK		0x51
#define DS_ERR_SYSCALL_SIGPROCMASK_BLOCK	0x52
#define DS_ERR_SYSCALL_SIGPROCMASK_UNBLOCK	0x53
#define DS_ERR_SYSCALL_SIGTIMEDWAIT		0x54
#define DS_ERR_SYSCALL_NANOSLEEP		0x55
#define DS_ERR_SYSCALL_PTHREAD_CREATE		0x60
#define DS_ERR_SYSCALL_PTHREAD_SIGMASK_BLOCK	0x61
#define DS_ERR_SYSCALL_PTHREAD_SIGMASK_UNBLOCK	0x62
#define DS_ERR_SYSCALL_PTHREAD_KEY_CREATE	0x63
#define DS_ERR_SYSCALL_PTHREAD_SET_SPECIFIC	0x64
#define DS_ERR_SYSCALL_PTHREAD_GET_SPECIFIC	0x65
#define DS_ERR_SYSCALL_PTHREAD_MUTEX_INIT	0x66
#define DS_ERR_SYSCALL_PTHREAD_MUTEX_LOCK	0x67
#define DS_ERR_SYSCALL_PTHREAD_MUTEX_UNLOCK	0x68
#define DS_ERR_SYSCALL_PTHREAD_COND_INIT	0x69
#define DS_ERR_SYSCALL_PTHREAD_COND_SEND	0x6A
#define DS_ERR_SYSCALL_PTHREAD_COND_WAIT	0x6B
#define DS_ERR_SYSCALL_PTHREAD_SETSCHEDPARAM	0x6C
#define DS_ERR_SYSCALL_FORK			0x6D

#define DS_ERR_SYSCALL_SELECT			0x90
#define DS_ERR_SYSCALL_PSELECT			0x91

#define DS_ERR_SYSCALL_LOCALTIME		0x70
#define DS_ERR_SYSCALL_GMTIME			0x71


#define DS_ERR_SOCKET				0x100
#define DS_ERR_SOCKET_CREATE			0x101
#define DS_ERR_SOCKET_BIND			0x102
#define DS_ERR_USED_BY_FUCKING_WINDOWS		0x103
#define DS_ERR_SOCKET_LISTEN			0x104
#define DS_ERR_SOCKET_SELECT			0x105
#define DS_ERR_SOCKET_IOCTL			0x106
#define DS_ERR_SOCKET_FCNTL			0x107
#define DS_ERR_SOCKET_READ			0x108
#define DS_ERR_SOCKET_WRITE			0x109
#define DS_ERR_SOCKET_ACCEPT			0x10A
#define DS_ERR_SOCKET_CONNECT			0x10B
#define DS_ERR_SOCKET_GETSOCKOPT		0x10C
#define DS_ERR_SOCKET_SETSOCKOPT		0x10D
#define DS_ERR_SOCKET_GETADDRINFO		0x10E
#define DS_ERR_SOCKET_GETHOSTBYNAME		0x10F


#define DS_ERR_FS				0x110
#define DS_ERR_FS_CHMOD				0x111

#define DS_ERR_WINAPI				0x150
#define DS_ERR_WINAPI_WINSOCK_INIT		0x151
#define DS_ERR_WINAPI_EVENT_CREATE		0x152
#define DS_ERR_WINAPI_PIPE_CREATE		0x153
#define DS_ERR_WINAPI_PIPE_CONNECT		0x154
#define DS_ERR_WINAPI_MUTEX_CREATE		0x155
#define DS_ERR_WINAPI_GETHOSTBYNAME		0x156


#define DS_ERR_BASETHREAD			0x200
#define DS_ERR_BASETHREAD_CREATE		0x201
#define DS_ERR_THREAD				0x202
#define DS_ERR_THREAD_CREATE			0x203
#define DS_ERR_THREAD_UNREGISTERED		0x204
#define DS_ERR_THREAD_CANCELED			0x205
#define DS_ERR_THREAD_RETURNCODE		0x206
#define DS_ERR_DOUBLETHREAD			0x207
#define DS_ERR_DOUBLETHREAD_CREATE		0x208

#define DS_ERR_CONNECTIONSERVER			0x210
#define DS_ERR_CONNECTIONSERVER_CREATE		0x211
#define DS_ERR_CONNECTIONSERVER_ADDRINUSE	0x212
#define DS_ERR_CONNECTION			0x215
#define DS_ERR_CONNECTION_CREATE		0x216
#define DS_ERR_CONNECTION_BROKENPIPE		0x217
#define DS_ERR_CONNECTION_NOTCONNECTED		0x218
#define DS_ERR_CONNECTION_CONNECTED		0x219
#define DS_ERR_CONNECTION_REFUSED		0x21A
#define DS_ERR_CONNECTION_TIMEOUT		0x21B
#define DS_ERR_CONNECTION_NETWORK		0x21C
#define DS_ERR_CONNECTION_CONNECT		0x21D
#define DS_ERR_CONNECTION_INVALID_SPEED		0x21E
#define DS_ERR_CONNECTION_READ			0x21F
#define DS_ERR_CONNECTION_WRITE			0x220
#define DS_ERR_CONNECTION_UNKNOWN_HOST		0x221
#define DS_ERR_CONNECTION_ADDRESS_TOO_LONG	0x222
#define DS_ERR_CONNECTION_ADDRESS_INVALID	0x223

#define DS_ERR_SIGNAL				0x230
#define DS_ERR_SIGNAL_CREATE			0x231
#define DS_ERR_SIGNAL_EVENT			0x232

#define DS_ERR_LOCK				0x240
#define DS_ERR_LOCK_CREATE			0x241
#define DS_ERR_LOCK_SELFLOCKED			0x243
#define DS_ERR_LOCK_NOTLOCKED			0x244
#define DS_ERR_CONDITION			0x245
#define DS_ERR_CONDITION_CREATE			0x246
#define DS_ERR_LOCK_BUSY			0x247

#define DS_ERR_FILE				0x250
#define DS_ERR_FILE_CREATE			0x251
#define DS_ERR_FILE_NOTFOUND			0x252
#define DS_ERR_FILE_OPEN			0x253
#define DS_ERR_DIRECTORY			0x255
#define DS_ERR_DIRECTORY_CREATE			0x256
#define DS_ERR_DIRECTORY_NOTFOUND		0x257
#define DS_ERR_DIRECTORY_NOTADIRECTORY		0x258


#define DS_ERR_PLUGIN				0x260
#define DS_ERR_PLUGIN_CREATE			0x261
#define DS_ERR_PLUGIN_LOAD			0x262
#define DS_ERR_PLUGIN_INFOFUNCTION		0x263
#define DS_ERR_PLUGIN_INVALIDINFO		0x264
#define DS_ERR_PLUGINSET			0x265
#define DS_ERR_PLUGINSET_CREATE			0x266
#define DS_ERR_PLUGINSET_PATH			0x267

#define DS_ERR_TIMECONVERT			0x270

#define DS_ERR_MALLOC						0x300
#define DS_ERR_MALLOC_CREATE					0x301

#define DS_ERR_ALLOCATOR					0x310
#define DS_ERR_ALLOCATOR_CREATE					0x311
#define DS_ERR_ALLOCATOR_INCOMPLETE				0x312
#define DS_ERR_ALLOCATOR_ALLOCATE				0x313
#define DS_ERR_ALLOCATOR_INVALID				0x314
#define DS_ERR_ALLOCATOR_NOTOWNER				0x315

#define DS_ERR_BUFFERPOOL					0x320
#define DS_ERR_BUFFERPOOL_CREATE				0x321
#define DS_ERR_BUFFERPOOL_GET					0x322
#define DS_ERR_BUFFERPOOL_SIMPLEBUFFER				0x323
#define DS_ERR_BUFFERPOOL_SIMPLEBUFFER_CREATE			0x324

#define DS_ERR_BUFFER						0x330
#define DS_ERR_BUFFER_CREATE					0x331
#define DS_ERR_DATABUFFER					0x332
#define DS_ERR_DATABUFFER_CREATE				0x333
#define DS_ERR_DATABUFFER_OPTIONS				0x334
#define DS_ERR_DATABUFFER_OPTIONS_MISSING_BUFFERPOOL		0x335
#define DS_ERR_DATABUFFER_OPTIONS_INVALID_BUFFERPOOL		0x336

#define DS_ERR_HOLDER						0x340
#define DS_ERR_HOLDER_CREATE					0x341
#define DS_ERR_HOLDER_BUSY					0x342
#define DS_ERR_HOLDERBUCKET					0x345
#define DS_ERR_HOLDERBUCKET_CREATE				0x346

#define DS_ERR_FORMAT						0x350
#define DS_ERR_FORMAT_CREATE					0x351
#define DS_ERR_FORMAT_CREATE_INSTANCE				0x352
#define DS_ERR_FORMAT_NATIVE_CREATE				0x353
#define DS_ERR_FORMAT_NATIVE_CREATE_INSTANCE			0x354

#define DS_ERR_HASHTABLE					0x400
#define DS_ERR_HASHTABLE_CREATE					0x401
#define DS_ERR_STRINGLIST					0x402
#define DS_ERR_STRINGLIST_CREATE				0x403
#define DS_ERR_DOUBLEHASH					0x404
#define DS_ERR_DOUBLEHASH_CREATE				0x405

#define DS_ERR_ENUMERATION					0x410
#define DS_ERR_ENUMERATION_CREATE				0x411
#define DS_ERR_ENUMERATION_INVALID_DESCRIPTION			0x412
#define DS_ERR_TREENODE						0x415
#define DS_ERR_TREENODE_CREATE					0x416

#define DS_ERR_BINARYCONFIGURATION				0x420
#define DS_ERR_BINARYCONFIGURATION_CREATE			0x421
#define DS_ERR_BINARYCONFIGURATION_UNKNOWN_FLOAT_FORMAT		0x422
#define DS_ERR_BINARYCONFIGURATION_UNKNOWN_ALLOCATION_ALIGMENT	0x423
#define DS_ERR_BINARYCONFIGURATION_UNKNOWN_STRUCT_ALIGNMENT	0x424

#define DS_ERR_DIME						0x430
#define DS_ERR_DIME_CREATE					0x431
#define DS_ERR_DIME_INVALID_TYPE				0x432

#define DS_ERR_ERROR						0x440
#define DS_ERR_ERROR_INIT					0x441
#define DS_ERR_DEBUG						0x442


#define DS_ERR_LOCALE						0x450
#define DS_ERR_LOCALE_CREATE					0x451
#define DS_ERR_LOCALE_DOMAIN					0x452
#define DS_ERR_LOCALE_DOMAIN_REGISTER				0x453
#define DS_ERR_LOCALE_DOMAIN_SET				0x454

#define DS_ERR_XML						0x500
#define DS_ERR_XML_PARSER					0x510
#define DS_ERR_XML_PARSER_CREATE				0x511
#define DS_ERR_XML_XSD						0x520
#define DS_ERR_XML_XSD_CREATE					0x521
#define DS_ERR_XML_XSLT						0x530
#define DS_ERR_XML_XSLT_CREATE					0x531
#define DS_ERR_XML_XPATH					0x540
#define DS_ERR_XML_XPATH_CREATE					0x541
#define DS_ERR_XML_XPATH_REGISTERNAMESPACE			0x542
#define DS_ERR_XML_WRITER					0x543
#define DS_ERR_XML_SCHEMA					0x550
#define DS_ERR_XML_SCHEMA_CREATE				0x551

#define DS_ERR_CONFIG						0x600
#define DS_ERR_CONFIG_INVALID_CONFIG				0x601
#define DS_ERR_CONIFG_NOTFOUND					0x602

#define DS_ERR_DATA_INVALID_TYPE_SIZE				0x700

#endif /* _DSLIB_ERROR_H */
