#ifndef _DSLIB_MODULE_H
#define _DSLIB_MODULE_H

#define DS_MODULE_Malloc				0x12
#define DS_MODULE_Lock					0x13
#define DS_MODULE_Signal				0x14
#define DS_MODULE_SystemLock				0x15
#define DS_MODULE_SystemService				0x16
#define DS_MODULE_Directory				0x17

#define DS_MODULE_Condition				0x20
#define DS_MODULE_BaseThread				0x24
#define DS_MODULE_Thread				0x25
#define DS_MODULE_DoubleThread				0x26
#define DS_MODULE_Plugin				0x2A
#define DS_MODULE_PluginSet				0x2B

#define DS_MODULE_Connection				0x30
#define DS_MODULE_ConnectionServer			0x31
#define DS_MODULE_DatagramServer			0x32

#define DS_MODULE_Locale				0xA0
#define DS_MODULE_String				0xA5
#define DS_MODULE_StringList				0xA6
#define DS_MODULE_HashTable				0xA7 /* Should be rewritten */
#define DS_MODULE_DoubleHash				0xA8

#define DS_MODULE_TreeNode				0xB0
#define DS_MODULE_TreeComplexNode			0xB1
#define DS_MODULE_Enumeration				0xB2

#define DS_MODULE_Config				0xC1

#define DS_MODULE_DataBase				0xD0

#define DS_MODULE_Buffer				0x101
#define DS_MODULE_BufferPool				0x102

#define DS_MODULE_Allocator				0x110
#define DS_MODULE_AllocatorSimple 			0x111
#define DS_MODULE_AllocatorDataBuffer			0x112

#define DS_MODULE_BinaryType 				0x120
#define DS_MODULE_OPCBinary				0x121
#define DS_MODULE_OPCBinaryDictionary			0x122

#define DS_MODULE_BinaryFormat				0x130
#define DS_MODULE_BinaryFormatNative			0x131
#define DS_MODULE_BinaryFormatOPCXML			0x132

#define DS_MODULE_DataChunk				0x140
#define DS_MODULE_ChunkPool				0x141

#define DS_MODULE_DataHolder				0x150
#define DS_MODULE_DataHolderBucket			0x151

#define DS_MODULE_DataConverter				0x160
#define DS_MODULE_Representation			0x161
#define DS_MODULE_RepresentationBinary			0x162

#define DS_MODULE_DataManager				0x161
#define DS_MODULE_DataManagerFast			0x162
#define DS_MODULE_DataManagerRep			0x163

#define DS_MODULE_Dispersion				0x200
#define DS_MODULE_Dime					0x201

#endif /* _DSLIB_MODULE_H */
