#ifndef _DSLIB_TYPES_H
#define _DSLIB_TYPES_H

#include <dslib_config.h>
#include <dsoop.h>



#if defined(HAVE_STDINT_H)
# include <stdint.h>
# if !defined(INT8_MAX)
    typedef int_least8_t int8_t;
# endif
#elif defined(HAVE_INTTYPES_H)
# include <inttypes.h>
#else /* defined(PREDEF_STANDARD_UNIX98) */
  typedef unsigned char		uint8_t;
  typedef unsigned short int	uint16_t;
# ifndef __uint32_t_defined
   typedef unsigned int		uint32_t;
#  define __uint32_t_defined
# endif
# if __WORDSIZE == 64
   typedef unsigned long int	uint64_t;
# else
   typedef unsigned long long int uint64_t;
# endif
# ifndef __int8_t_defined
# define __int8_t_defined
   typedef signed char		int8_t;
   typedef short int		int16_t;
   typedef int			int32_t;
#  if __WORDSIZE == 64
    typedef long int		int64_t;
#  else
    typedef long long int	int64_t;
#  endif
# endif
#endif /* defined(PREDEF_STANDARD_UNIX98) */

typedef unsigned long dword;
typedef unsigned int word;

#ifdef _WIN32
# ifdef HAVE_WINSOCK2
#  include <winsock2.h>
#  define _WINSOCKAPI_
# else
#  include <winsock.h>
# endif /* HAVE_WINSOCK2 */
# include <windows.h>
#endif /* _WIN32 */

#ifndef HAVE_PTHREAD_H
# ifdef HAVE_WIN32_THREADS
    typedef HANDLE pthread_t;
# endif
#endif /* !HAVE_PTHREAD_H */

#ifndef HAVE_NETINET_IN_H
    typedef uint16_t in_port_t;
#endif /* !HAVE_NETINET_IN_H */

#ifndef HAVE_TIMEVAL
# define HAVE_TIMEVAL		1
typedef struct timeval {
    long tv_sec;
    long tv_usec;
};
#endif /* !HAVE_TIMEVAL */

#ifndef HAVE_TIMESPEC
# define HAVE_TIMESPEC		1
typedef struct timespec {
    long tv_sec;
    long tv_nsec;
};
#endif /* !HAVE_TIMESPEC */


#ifndef HAVE_ERRNO_H
int errno = -1;
#endif /* !HAVE_ERRNO_H */

#ifdef _WIN32
typedef size_t socklen_t;
typedef int uid_t;
typedef int gid_t;
typedef unsigned short mode_t;
typedef int suseconds_t;
#endif /* _WIN32 */

#ifdef _WIN32
# define PTR2INT(ptr) ((unsigned long)((char*)ptr - NULL))
#else /* _WIN32 */
# define PTR2INT(ptr) ((unsigned long)(ptr))
#endif /* _WIN32 */

#endif /* _DSLIB_TYPES_H */
