#include <stdio.h>
#include <dslib.h>

#ifdef HAVE_UNISTD_H
# include <unistd.h>
#endif /* HAVE_UNISTD_H */
#ifdef HAVE_NETDB_H
# include <netdb.h>
#endif /* HAVE_NETDB_H */


char *dsGetHostName(DSMallocContext mctx, char with_domain) {
#ifdef HAVE_UNISTD_H
    int err;
    char *res = NULL;
    char host[256];
    struct hostent *hp;
    
    err = gethostname(host, sizeof(host)-1);
    if (err) return NULL;

    if (with_domain) hp = gethostbyname(host);
    else hp = NULL;
    
    if (hp) err = dsExchangeString(mctx, &res, hp->h_name);
    else err = dsExchangeString(mctx, &res, host);

    if (err) return NULL;
    return res;
#else /* HAVE_UNISTD_H */
    return NULL;
#endif /* HAVE_UNISTD_H */
}
