#ifndef _DS_PLUGINSET_H
#define _DS_PLUGINSET_H

#include <dsplugin.h>
#include <dsmalloc.h>

struct DSPluginSetContextT {
    DSMallocContext malloc;

    char *path;
    void *plugin_attribute;
    DSPluginContext plugin;
    int run;
};

typedef struct DSPluginSetContextT *DSPluginSetContext;

DSPluginSetContext dsPluginSetCreateContext(DSMallocContext mctx);
int dsPluginSetInitContext(DSPluginSetContext ctx, const char *path, void *attr);
void dsPluginSetZeroContext(DSPluginSetContext ctx);
void dsPluginSetFreeContext(DSPluginSetContext ctx);
void dsPluginSetDestroyContext(DSPluginSetContext ctx);

int dsPluginSetRescanDir(DSPluginSetContext ctx);


/* 
    Currently realesed in following way. 
    I think all plugins step by step comming to required Status. I mean if sometime one of 
    plugins get right status value, it's actualy will presist same until all others don't get
    to this status.
    
    It's possible do in standard way but I think this one is correct one for required purposes.
    And implementing standard one may finish in numerous deadlocks.
    
    See dsthread.h
*/

void dsPluginSetSetStatus(DSPluginSetContext ctx, dword bits);
void dsPluginSetSetStatusBits(DSPluginSetContext ctx, dword bits);
void dsPluginSetResetStatusBits(DSPluginSetContext ctx, dword bits);
int dsPluginSetCheckStatusBitsOn(DSPluginSetContext ctx, dword bits);
int dsPluginSetCheckStatusBitsOff(DSPluginSetContext ctx, dword bits);
int dsPluginSetCheckStatusBits(DSPluginSetContext ctx, dword onbits, dword offbits);
int dsPluginSetCheckStatusSomeBitsOn(DSPluginSetContext ctx, dword bits);
int dsPluginSetCheckStatusSomeBitsOff(DSPluginSetContext ctx, dword bits);
int dsPluginSetCheckStatusSomeBits(DSPluginSetContext ctx, dword onbits, dword offbits);
void dsPluginSetWaitStatusBitsOn(DSPluginSetContext ctx, dword bits);
void dsPluginSetWaitStatusBitsOff(DSPluginSetContext ctx, dword bits);
void dsPluginSetWaitStatusBits(DSPluginSetContext ctx, dword onbits, dword offbits);
void dsPluginSetWaitStatusSomeBitsOn(DSPluginSetContext ctx, dword bits);
void dsPluginSetWaitStatusSomeBitsOff(DSPluginSetContext ctx, dword bits);
void dsPluginSetWaitStatusSomeBits(DSPluginSetContext ctx, dword onbits, dword offbits);
void dsPluginSetWaitTerminate(DSPluginSetContext ctx);
void dsPluginSetTerminateAndWait(DSPluginSetContext ctx);
int dsPluginSetIsTerminated(DSPluginSetContext ctx);

int dsPluginSetStart(DSPluginSetContext ctx);
int dsPluginSetStop(DSPluginSetContext ctx);
int dsPluginSetBreak(DSPluginSetContext ctx);
int dsPluginSetTerminate(DSPluginSetContext ctx);
void dsPluginSetWaitTerminate(DSPluginSetContext ctx);
void dsPluginSetTerminateAndWait(DSPluginSetContext ctx);
int dsPluginSetIsTerminated(DSPluginSetContext ctx);

#endif /* _DS_PLUGINSET_H */
