#ifndef _DS_SOFT_SIGNAL_H
#define _DS_SOFT_SIGNAL_H

#include <dslib.h>

typedef struct DSSoftSignalContextT *DSSoftSignalContext;
typedef DSSoftSignalContext *DSSoftSignalList; // NULL terminated

#include <dstime.h>

    // LIMITATION: Single waiter expected
struct DSSoftSignalContextT {
    DSMallocContext malloc;
#ifdef _WIN32
    HANDLE h;
#else /* _WIN32 */
    int r,w;
#endif /* _WIN32 */
};
typedef struct DSSoftSignalContextT DSSoftSignalContextS;


DSSoftSignalContext dsSoftSignalCreateContext(DSMallocContext mctx);
int dsSoftSignalInitContext(DSSoftSignalContext ctx);
void dsSoftSignalFreeContext(DSSoftSignalContext ctx);
void dsSoftSignalDestroyContext(DSSoftSignalContext ctx);

int dsSoftSignalClean(DSSoftSignalContext ctx);
int dsSoftSignalSend(DSSoftSignalContext ctx);

int dsSoftSignalWait(DSSoftSignalContext ctx, DSDurationConst duration);
int dsSoftSignalWaitRT(DSSoftSignalContext ctx, DSDurationConst duration);
int dsSoftSignalWaitUntil(DSSoftSignalContext ctx, DSTimeConst time);
int dsSoftSignalWaitRTUntil(DSSoftSignalContext ctx, DSTimeConst time);

int dsSoftSignalWaitSeconds(DSSoftSignalContext ctx, time_t s);
int dsSoftSignalWaitMillseconds(DSSoftSignalContext ctx, unsigned long ms);
int dsSoftSignalWaitMicroseconds(DSSoftSignalContext ctx, unsigned long us);
int dsSoftSignalWaitMicrosecondsRT(DSSoftSignalContext ctx, unsigned long us);

#endif /* _DS_SOFT_SIGNAL_H */
