#ifndef _DS_SYSTEM_LOCK
#define _DS_SYSTEM_LOCK

#include <dslib.h>
#include <dsmalloc.h>

struct DSSystemLockContextT {
    DSMallocContext malloc;
    char *name;    
#ifdef _WIN32
    HANDLE lockfd;
#else
    int lockfd;
#endif /* _WIN32 */
};

typedef struct DSSystemLockContextT DSSystemLockContextS;
typedef struct DSSystemLockContextT *DSSystemLockContext;

DSSystemLockContext dsSystemLockCreateContext(DSMallocContext mctx);
int dsSystemLockInitContext(DSSystemLockContext ctx, const char *name);
void dsSystemLockFreeContext(DSSystemLockContext ctx);
void dsSystemLockDestroyContext(DSSystemLockContext ctx);

int dsSystemLockAcquire(DSSystemLockContext ctx);
int dsSystemLockWait(DSSystemLockContext ctx);
int dsSystemLockReturn(DSSystemLockContext ctx);

#endif /* _DS_SYSTEM_LOCK */
