#ifndef _DS_THREAD_H
#define _DS_THREAD_H

#include <dslib.h>

#if defined(HAVE_PTHREAD_H)
# include <pthread.h>
#elif defined(HAVE_WIN32_THREADS)
# include <windows.h>
#else /* defined(HAVE_PTHREAD_H) */
# error "Missing threading library!"
#endif /* defined(HAVE_PTHREAD_H) */

#include <dsbasethread.h>

#define DS_THREAD_JOINREQUIRED_FLAG 2
#define DS_THREAD_RUNNING_FLAG 4

struct DSThreadContextT {
    struct DSBaseThreadContextT base;

    DSThreadRealHandleS thread;
};

typedef struct DSThreadContextT *DSThreadContext;
typedef struct DSThreadContextT DSThreadContextS;




DSThreadContext dsThreadCreateContext(DSMallocContext mctx);
int dsThreadInitContext(DSThreadContext ctx);
int dsThreadFreeContext(DSThreadContext ctx);
int dsThreadDestroyContext(DSThreadContext ctx);
void dsThreadZeroContext(DSThreadContext ctx);


void dsThreadNotify(DSThreadContext ctx);

int dsThreadRun(DSThreadContext ctx, DSThreadFunction thread_function, void *attr);
int dsThreadWaitTerminate(DSThreadContext ctx);
int dsThreadTerminateAndWait(DSThreadContext ctx);
int dsThreadIsRunning(DSThreadContext ctx);

#endif /* _DS_THREAD_H */
