#ifndef _DS_DIME_H
#define _DS_DIME_H

#include <dslib.h>

/*
    Simplified DIME header generation library.
*/


typedef void *DSDimeHeader;

typedef enum DSDimeTypeT DSDimeType;

enum DSDimeTypeT {
    DS_DIME_TYPE_NOTAPPLICABLE = 0,
    DS_DIME_TYPE_MIME,
    DS_DIME_TYPE_URI,
    DS_DIME_TYPE_NONE,
    DS_DIME_TYPE_BINARY,
    DS_DIME_TYPE_XML
};


int dsDimeSendHeader(const char *id, unsigned long size, DSDimeType type, const char *type_name, unsigned char first, unsigned char last, unsigned char chunked, DSSendFunction func, void *cctx);
int dsDimeSendChunk(unsigned long size, unsigned char last, DSSendFunction func, void *cctx);
int dsDimeSendCloseChunk(DSSendFunction func, void *cctx);
int dsDimeSendCloseRecord(DSSendFunction func, void *cctx);

#endif /* _DS_DIME_H */
