#ifndef _DS_ENUMERATION_H
#define _DS_ENUMERATION_H

#include <dsmalloc.h>
#include <dshashtable.h>

typedef struct DSEnumerationBucketT *DSEnumerationBucket;
struct DSEnumerationBucketT {
    char *string;
    unsigned long id;
};


typedef struct DSEnumerationContextT *DSEnumerationContext;
struct DSEnumerationContextT {
    DSMallocContext malloc;
    DSHashTable hash;
    DSEnumerationBucket bucket;
    unsigned char destroy_bucket;
    unsigned long maxid;
    char *string;
};

void dsEnumerationZeroContext(DSEnumerationContext ctx);
DSEnumerationContext dsEnumerationCreateContext(DSMallocContext mctx);
// Assuming what bucket will persist in memory whole live cickle
int dsEnumerationInitContext(DSEnumerationContext ctx, DSEnumerationBucket bucket);
int dsEnumerationInitContextFromArray(DSEnumerationContext ctx, const char **title_array, unsigned char copy_strings);
int dsEnumerationInitContextFromString(DSEnumerationContext ctx, const char *titles, unsigned char copy_string);
void dsEnumerationFreeContext(DSEnumerationContext ctx);
void dsEnumerationDestroyContext(DSEnumerationContext ctx);

unsigned long dsEnumerationGetID(DSEnumerationContext ctx, const char *str);
const char *dsEnumerationGetString(DSEnumerationContext ctx, unsigned long number);
DSEnumerationBucket dsEnumerationGetBucketByString(DSEnumerationContext ctx, const char *str);
DSEnumerationBucket dsEnumerationGetBucketByID(DSEnumerationContext ctx, unsigned long number);

#endif /* _DS_ENUMERATION_H */
