#ifndef _DS_STRING_H
#define _DS_STRING_H

#include <stdarg.h>
#include <dsmalloc.h>

typedef char *DSString;
typedef const char *DSStringConstant;

/*
    dsStringCreate:	Considering 's' is an ASCII string. All UTF-8 characters should be passed
			in %s parameters.
*/
DSString dsStringCreate(DSMallocContext mctx, const char *s, ...);
DSString dsStringVCreate(DSMallocContext mctx, const char *s, va_list ap);
void dsStringDestroy(DSMallocContext mctx, DSString str);


int dsStringExchange(DSMallocContext mctx, DSString *str, DSStringConstant s);
int dsStringExchangeBytes(DSMallocContext mctx, DSString *str, DSStringConstant s, unsigned int bytes);
DSString dsStringCopy(DSMallocContext mctx, DSStringConstant str);

DSStringConstant dsStringStrchr(DSStringConstant str, char ch);
DSStringConstant dsStringStrrchr(DSStringConstant str, char ch);
DSStringConstant dsStringStrstr(DSStringConstant str, DSStringConstant sub);

#endif /* _DS_STRING_H */
