#ifndef _DS_STRINGLIST_H
#define _DS_STRINGLIST_H

#include <dsmalloc.h>

typedef struct DSStringListT *DSStringList;

struct DSStringListT {
    DSMallocContext malloc;
    void *item;
    unsigned long size;
    DSStringList next;
    DSStringList free;
};

DSStringList dsStringListCreate(DSMallocContext mctx);
void dsStringListFree(DSStringList list);
void dsStringListDestroy(DSStringList list);
int dsStringListAdd(DSStringList list, const void *item, unsigned long size);
int dsStringListIsIn(DSStringList list, const void *item, unsigned long size);
int dsStringListRemove(DSStringList list, const void *item, unsigned long size);
int dsStringListRemoveMulti(DSStringList list, const void *item, unsigned long size);
int dsStringListIsEmpty(DSStringList list);

#endif /* _DS_STRINGLIST_H */
