#ifndef _DS_TREE_NODE_H
#define _DS_TREE_NODE_H

#include <dslib.h>

typedef struct DSTreeNodeContextT *DSTreeNodeContext;
typedef struct DSTreeComplexNodeContextT *DSTreeComplexNodeContext;

struct DSTreeNodeContextT {
    DSMallocContext malloc;
    DSDestroyContextFunction destructor;
    DSTreeComplexNodeContext parrent;
    DSTreeNodeContext next, prev;
};


void dsTreeNodeZeroContext(DSTreeNodeContext ctx);
DSTreeNodeContext dsTreeNodeCreateContext(DSMallocContext mctx);
int dsTreeNodeInitContext(DSTreeNodeContext ctx, DSDestroyContextFunction destructor);
void dsTreeNodeFreeContext(DSTreeNodeContext ctx);
void dsTreeNodeDestroyContext(DSTreeNodeContext ctx);

int dsTreeNodeUnlink(DSTreeNodeContext ctx);
int dsTreeNodeInsertAfter(DSTreeNodeContext ctx, DSTreeNodeContext sibling);
int dsTreeNodeInsertBefore(DSTreeNodeContext ctx, DSTreeNodeContext sibling);


struct DSTreeComplexNodeContextT {
    struct DSTreeNodeContextT node;
    DSTreeNodeContext first_child, last_child;
};

void dsTreeComplexNodeZeroContext(DSTreeComplexNodeContext ctx);
DSTreeComplexNodeContext dsTreeComplexNodeCreateContext(DSMallocContext mctx);
int dsTreeComplexNodeInitContext(DSTreeComplexNodeContext ctx, DSDestroyContextFunction destructor);
void dsTreeComplexNodeFreeContext(DSTreeComplexNodeContext ctx);
void dsTreeComplexNodeDestroyContext(DSTreeComplexNodeContext ctx);

int dsTreeComplexNodeAddChild(DSTreeComplexNodeContext ctx, DSTreeNodeContext child);


#endif /* _DS_TREE_NODE_H */
