#ifndef _OPCLIB_ERROR_H
#define _OPCLIB_ERROR_H


#define OPC_ERR							0x1000
#define OPC_ERR_CREATE						0x1001

#define OPC_ERR_INTERFACE					0x1100
#define OPC_ERR_INTERFACE_GET_SERVERTREE			0x1110
#define OPC_ERR_INTERFACE_GET_CONFIGURATION			0x1111

#define OPC_ERR_SERVERINTERFACE					0x1110

#define OPC_ERR_STATE						0x1120
#define OPC_ERR_STATE_CREATE					0x1121
#define OPC_ERR_STATE_INVALID_STATE				0x1122

#define OPC_ERR_SERVERTREE					0x1150
#define OPC_ERR_SERVERTREE_CREATE				0x1151
#define OPC_ERR_SERVERTREE_ALREADY_REGISTERED			0x1153
#define OPC_ERR_SERVERTREE_CREATE_PATH				0x1154
#define OPC_ERR_SERVERTREE_ITEM_HAVE_MANUAL_CHILDS		0x1155
#define OPC_ERR_SERVERTREE_ITEM_NOTFOUND			0x1156
#define OPC_ERR_SERVERTREE_ITEM_NOTLINKED			0x1157

#define OPC_ERR_ITEM						0x1160
#define OPC_ERR_ITEM_CREATE					0x1161
#define OPC_ERR_ITEM_FILTERED					0x1162
#define OPC_ERR_ITEM_NOTCONNECTED				0x1163
#define OPC_ERR_ITEM_OUTOFDATE					0x1164
#define OPC_ERR_ITEM_OUTOFDATE_REACQUIRING			0x1165

/*
#define OPC_ERR_ITEM_INIT		0x3100000
#define OPC_ERR_ITEM_ALREDY_REGISTERED	0x3100001
#define OPC_ERR_ITEM_ALREDY_DESTROYED	0x3100002
#define OPC_ERR_ITEM_CREATE_PATH	0x3100003
#define OPC_ERR_ITEM_HAVE_MANUAL_CHILDS 0x3100004
#define OPC_ERR_ITEM_NOT_LINKED_TO_TREE 0x3100005
#define OPC_ERR_ITEM_FILTERED		0x3100006
#define OPC_ERR_ITEM_NOTFOUND		0x3100007
#define OPC_ERR_ITEM_MISSINGDATA	0x3100009
#define OPC_ERR_ITEM_CREATE_DATAMANAGER	0x310000A
#define OPC_ERR_ITEM_PARAMS		0x310000B
#define OPC_ERR_ITEM_SERVER_NOTFOUND	0x310000C
#define OPC_ERR_ITEM_SERVER_INCOMPLETE	0x310000D



#define OPC_ERR_FORMATS								0x1200
#define OPC_ERR_FORMATS_CREATE							0x1201
#define OPC_ERR_FORMATS_INCOMPLETE						0x1202
#define OPC_ERR_FORMATS_REGISTER						0x1205
#define OPC_ERR_FORMATS_REGISTER_NATIVE						0x1206
#define OPC_ERR_FORMATS_REGISTER_OPCXML						0x1207
#define OPC_ERR_FORMATS_REGISTER_ALREADY_REGISTERED				0x1208
#define OPC_ERR_FORMATS_MISSING							0x1209
#define OPC_ERR_FORMATS_MISSING_NATIVE						0x120A
#define OPC_ERR_FORMATS_MISSING_OPCXML						0x120B


#define OPC_ERR_FORMAT								0x1210
#define OPC_ERR_FORMAT_CREATE							0x1211
#define OPC_ERR_FORMAT_INCOMPLETE						0x1212
#define OPC_ERR_FORMAT_MISSING_METHOD_SEND					0x1213
#define OPC_ERR_FORMAT_MISSING_METHOD_IMPORTDATA				0x1214
#define OPC_ERR_FORMAT_MISSING_METHOD_READNATIVE				0x1215
#define OPC_ERR_FORMAT_MISSING_METHOD_WRITENATIVE				0x1216

#define OPC_ERR_FD_OPCBINARY							0x1221
#define OPC_ERR_FD_OPCBINARY_CREATE						0x1222
#define OPC_ERR_FD_OPCBINARY_PARSE						0x1223
#define OPC_ERR_FD_OPCBINARY_VALIDATE						0x1224
#define OPC_ERR_FD_OPCBINARY_DICTIONARY						0x1230
#define OPC_ERR_FD_OPCBINARY_DICTIONARY_CREATE					0x1231
#define OPC_ERR_FD_OPCBINARY_DICTIONARY_FIND					0x1232
#define OPC_ERR_FD_OPCBINARY_DICTIONARY_INVALID_ENDIANESS			0x1233
#define OPC_ERR_FD_OPCBINARY_DICTIONARY_INVALID_FLOATINGFORMAT			0x1234

#define OPC_ERR_FORMAT_NATIVE							0x1240
#define OPC_ERR_FORMAT_NATIVE_CREATE						0x1241
#define OPC_ERR_FORMAT_NATIVE_TYPE_NOTIMPLEMENTED				0x1243
#define OPC_ERR_FORMAT_BINARY							0x1250
#define OPC_ERR_FORMAT_BINARY_CREATE						0x1251
#define OPC_ERR_FORMAT_BINARY_TYPE_NOTIMPLEMENTED				0x1253
#define OPC_ERR_FORMAT_OPCXML							0x1270
#define OPC_ERR_FORMAT_OPCXML_CREATE						0x1271
#define OPC_ERR_FORMAT_OPCXML_TYPE_NOTIMPLEMENTED				0x1273
#define OPC_ERR_FORMAT_XML							0x1290
#define OPC_ERR_FORMAT_XML_CREATE						0x1291
#define OPC_ERR_FORMAT_TYPE_NOTIMPLEMENTED					0x1293

#define OPC_ERR_TYPE								0x1300
#define OPC_ERR_TYPE_CREATE							0x1301
#define OPC_ERR_TYPE_NOTIMPLEMENTED						0x1302
#define OPC_ERR_TYPE_NOTSUPPORTED_BY_FORMAT					0x1303
#define OPC_ERR_TYPE_INVALID_SIZE						0x1304
#define OPC_ERR_TYPE_STANDARD							0x1305
#define OPC_ERR_TYPE_STANDARD_CREATE						0x1306

#define OPC_ERR_FORMAT_OPCXML_INTEGER_READ					0x1310
#define OPC_ERR_FORMAT_OPCXML_INTEGER_READ_OPTION_NOTIMPLEMENTED		0x1311
#define OPC_ERR_FORMAT_OPCXML_INTEGER_WRITE					0x1315
#define OPC_ERR_FORMAT_OPCXML_INTEGER_WRITE_OPTION_NOTIMPLEMENTED		0x1316

#define OPC_ERR_FORMAT_OPCXML_FLOAT_READ					0x1320
#define OPC_ERR_FORMAT_OPCXML_FLOAT_READ_OPTION_NOTIMPLEMENTED			0x1321
#define OPC_ERR_FORMAT_OPCXML_FLOAT_WRITE					0x1325
#define OPC_ERR_FORMAT_OPCXML_FLOAT_WRITE_OPTION_NOTIMPLEMENTED			0x1326


#define OPC_ERR_DATAMANAGER							0x1400
#define OPC_ERR_DATAMANAGER_CREATE						0x1401
#define OPC_ERR_DATAMANAGER_CREATE_DATAFAST_MANAGER				0x1402
#define OPC_ERR_DATAMANAGER_CREATE_DATA_MANAGER					0x1403
#define OPC_ERR_DATAMANAGER_REPRESENTATION_ALREADY_REGISTERED			0x1404

#define OPC_ERR_DATAFAST							0x1410
#define OPC_ERR_DATAFAST_CREATE							0x1411
#define OPC_ERR_DATAFAST_ALLOCATOR_BUSY						0x1412
#define OPC_ERR_DATA								0x1420
#define OPC_ERR_DATA_CREATE							0x1421

#define OPC_ERR_CHUNKPOOL							0x1430
#define OPC_ERR_CHUNKPOOL_CREATE						0x1431
#define OPC_ERR_CHUNKPOOL_GET							0x1432
#define OPC_ERR_DATACHUNK							0x1436
#define OPC_ERR_DATACHUNK_CREATE						0x1437

#define OPC_ERR_REPRESENTATION							0x1440
#define OPC_ERR_REPRESENTATION_CREATE						0x1441
#define OPC_ERR_REPRESENTATION_CREATE_NATIVE					0x1442
#define OPC_ERR_REPRESENTATION_CREATE_OPCXML					0x1443
#define OPC_ERR_REPRESENTATION_MISSING						0x1444
#define OPC_ERR_REPRESENTATION_MISSING_NATIVE					0x1445
#define OPC_ERR_REPRESENTATION_MISSING_OPCXML					0x1446
#define OPC_ERR_REPRESENTATION_INCOMPLETE					0x1447
#define OPC_ERR_REPRESENTATION_DISABLED						0x144A

#define OPC_ERR_DATAREPRESENTATION						0x1450
#define OPC_ERR_DATAREPRESENTATION_CREATE					0x1451
#define OPC_ERR_DATAREPRESENTATION_INCOMPLETE					0x1452
#define OPC_ERR_DATAREPRESENTATION_OPTIONS					0x1453
#define OPC_ERR_DATAREPRESENTATION_OPTIONS_INCOMPLETE				0x1454
#define OPC_ERR_DATAREPRESENTATION_ALLOCATOR_NOTSUPPOPRTED			0x1455
#define OPC_ERR_DATAREPRESENTATION_CONVERT_NOTSUPPORTED				0x1456
*/

#define OPC_ERR_PROPERTIES							0x1500
#define OPC_ERR_PROPERTIES_CREATE						0x1501
#define OPC_ERR_PROPERTIES_INVALID_PROPERTY					0x1502
#define OPC_ERR_PROPERTIES_ALREADY_REGISTERED					0x1503
#define OPC_ERR_PROPERTIES_ID_USED						0x1504
#define OPC_ERR_PROPERTIES_LIMIT_EXCEEDED					0x1505

#define OPC_ERR_PROPERTY							0x1510
#define OPC_ERR_PROPERTY_CREATE							0x1511


#define OPC_ERR_FRONTEND								0x1600
#define OPC_ERR_FRONTEND_CREATE								0x1601
#define OPC_ERR_FRONTEND_REQUEST							0x1602
#define OPC_ERR_FRONTEND_REQUEST_CREATE							0x1603
#define OPC_ERR_FRRONTED_REQUEST_INVALID						0x1604


#define OPC_ERR_XLIB									0x1610
#define OPC_ERR_XLIB_CREATE								0x1611
#define OPC_ERR_XLIB_COMMANDS_INIT							0x1612
#define OPC_ERR_XLIB_INVALID_SCHEMA							0x1613
#define OPC_ERR_XLIB_PARSER_CREATE							0x1614

#define OPC_ERR_XLIB_REQUEST								0x1650
#define OPC_ERR_XLIB_REQUEST_CREATE							0x1651
#define OPC_ERR_XLIB_REQUEST_INVALID							0x1652
#define OPC_ERR_XLIB_REQUEST_PARSE							0x1653
#define OPC_ERR_XLIB_REQUEST_PARSE_CHUNK_TO_SMALL					0x1654

#define OPC_ERR_XLIB_REQUEST_VALIDATE							0x1660
#define OPC_ERR_XLIB_REQUEST_VALIDATE_EMPTY						0x1661
#define OPC_ERR_XLIB_REQUEST_VALIDATE_NOTFOUND_NS					0x1662
#define OPC_ERR_XLIB_REQUEST_VALIDATE_NOTFOUND_ITEMNAME					0x1681

#define OPC_ERR_XLIB_REQUEST_PROCESS							0x1670
#define OPC_ERR_XLIB_REQUEST_PROCESS_UNKNOWN_REQUEST					0x1671
#define OPC_ERR_XLIB_REQUEST_PROCESS_UNSUPPORTED_REQUEST				0x1672
#define OPC_ERR_XLIB_REQUEST_PROCESS_INVALID_REQUEST					0x1673
#define OPC_ERR_XLIB_REQUEST_PROCESS_MORE_ITEMS						0x1675
#define OPC_ERR_XLIB_REQUEST_PROCESS_NOMORE_ITEMS					0x1676

#define OPC_ERR_XLIB_REQUEST_PROCESS_ITEM						0x1680
#define OPC_ERR_XLIB_REQUEST_PROCESS_ITEM_NOTFOUND					0x1682

#define OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE						0x1690
#define OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_BROWSE_FILTER			0x1691
#define OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_VENDOR_FILTER			0x1692
#define OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_NAME_FILTER				0x1693
#define OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_RETURNED_ELEMENTS_NUMBER		0x1694

#define OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT					0x16A0
#define OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID				0x16A1
#define OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_TIMEDOUT			0x16A2
#define OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_BROWSE_FILTER		0x16A3
#define OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_VENDOR_FILTER		0x16A4
#define OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_NAME_FILTER		0x16A5
#define OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_ITEMNAME		0x16A6

#define OPC_ERR_XLIB_REQUEST_SERIALIZE							0x16F0
#define OPC_ERR_XLIB_REQUEST_SERIALIZE_START						0x16F1
#define OPC_ERR_XLIB_REQUEST_SERIALIZE_FINISH						0x16F2



/*

#define OPC_ERR_XLIB_CREATEPARSER 	0x4000000
#define OPC_ERR_XLIB_CHUNKSMALL 	0x4000001
#define OPC_ERR_XLIB_CHUNKBIG 		0x4000002

#define OPC_ERR_XLIB_PARSEREQUEST	0x4000100
#define OPC_ERR_XLIB_REQUESTEMPTY	0x4000101
#define OPC_ERR_XLIB_NSNOTFOUND		0x4000102

#define OPC_ERR_XLIB_INVALID_RETURNED_ELEMENTS_NUMBER	0x4000201

*/

//#define OPC_ERR_XLIB_GET_BUFFER					0x1602




#endif /* _OPCLIB_ERROR_H */
