#ifndef _OPC_H
#define _OPC_H

typedef struct OPCContextT *OPCContext;

#include <dsmalloc.h>
#include <dstime.h>

#include <dsholder.h>
#include <dschunkpool.h>
#include <dsbufferpool.h>
#include <dsopcbinary.h>

#include <opcversion.h>
#include <opcstate.h>
#include <opclocales.h>
#include <opcproperties.h>
#include <opctree.h>
#include <opcconfiguration.h>

struct OPCContextT {
    DSMallocContext malloc;
    OPCStateContext state;
    OPCVersion version;
    DSTime start_time;
    OPCLocalesContext locales;
    OPCTreeContext tree;
    DSHolderContext holder;


    DSOPCBinaryContext fd_opcbinary;
    DSChunkPoolContext chunks;
    DSBufferPoolContext buffers;
    OPCPropertiesContext properties;
    
    OPCConfigurationContext config;
};

int opcInit();
void opcDestroy();

OPCContext opcCreateContext(DSMallocContext malloc);
int opcInitContext(OPCContext ctx, OPCConfigurationContext cfg, unsigned long scalbility);
void opcFreeContext(OPCContext ctx);
void opcDestroyContext(OPCContext ctx);
void opcMantain(OPCContext ctx);

#endif /* _OPC_H */
