#ifndef _OPC_DATA_INFO_H
#define _OPC_DATA_INFO_H

#include <dsmalloc.h>
#include <dstime.h>
#include <opcquality.h>

#include <dsdata.h>

struct OPCDataInfoT {
    DSMallocContext malloc;
    DSTimeS time;
    OPCQualityS quality;
};

typedef struct OPCDataInfoT OPCDataInfoS;
typedef struct OPCDataInfoT *OPCDataInfo;

OPCDataInfo opcDataInfoCreate(DSMallocContext mctx);
void opcDataInfoDestroy(DSMallocContext mctx, OPCDataInfo info);
int opcDataInfoSetup(OPCDataInfo info);

int opcDataInfoSetTime(OPCDataInfo info, DSTime time);
int opcDataInfoSetQuality(OPCDataInfo info, OPCQuality quality);

DSTimeConst opcDataInfoGetTime(OPCDataInfo info);
OPCQualityConst opcDataInfoGetQuality(OPCDataInfo info);

DSData opcDataInfoCreateEnclosed(DSMallocContext mctx);
DSData opcDataInfoEnclosureCreate(OPCDataInfo info, DSMallocContext mctx);
int opcDataInfoEnclosureSetup(DSData data, OPCDataInfo info);
int opcDataInfoEnclosurePassOwnership(DSData data, DSMallocContext owner);
OPCDataInfo opcDataInfoEnclosureExtract(DSData data);

int opcDataInfoCopy(OPCDataInfo dst, OPCDataInfo src);

#endif /* _OPC_DATA_INFO_H */
