#ifndef _OPC_ERROR_H
#define _OPC_ERROR_H

#include <dserror.h>

int opcErrorInit();
void opcErrorDestroy();

#ifdef _OPC_ERROR_C
static DSErrorS opc_errors[] = {
	{0x1001, opc_string("OPC_ERR_CREATE")},
	{0x1100, opc_string("OPC_ERR_INTERFACE")},
	{0x1110, opc_string("OPC_ERR_INTERFACE_GET_SERVERTREE")},
	{0x1111, opc_string("OPC_ERR_INTERFACE_GET_CONFIGURATION")},
	{0x1110, opc_string("OPC_ERR_SERVERINTERFACE")},
	{0x1120, opc_string("OPC_ERR_STATE")},
	{0x1121, opc_string("OPC_ERR_STATE_CREATE")},
	{0x1122, opc_string("OPC_ERR_STATE_INVALID_STATE")},
	{0x1150, opc_string("OPC_ERR_SERVERTREE")},
	{0x1151, opc_string("OPC_ERR_SERVERTREE_CREATE")},
	{0x1153, opc_string("OPC_ERR_SERVERTREE_ALREADY_REGISTERED")},
	{0x1154, opc_string("OPC_ERR_SERVERTREE_CREATE_PATH")},
	{0x1155, opc_string("OPC_ERR_SERVERTREE_ITEM_HAVE_MANUAL_CHILDS")},
	{0x1156, opc_string("OPC_ERR_SERVERTREE_ITEM_NOTFOUND")},
	{0x1157, opc_string("OPC_ERR_SERVERTREE_ITEM_NOTLINKED")},
	{0x1160, opc_string("OPC_ERR_ITEM")},
	{0x1161, opc_string("OPC_ERR_ITEM_CREATE")},
	{0x1162, opc_string("OPC_ERR_ITEM_FILTERED")},
	{0x1163, opc_string("OPC_ERR_ITEM_NOTCONNECTED")},
	{0x1164, opc_string("OPC_ERR_ITEM_OUTOFDATE")},
	{0x1165, opc_string("OPC_ERR_ITEM_OUTOFDATE_REACQUIRING")},
	{0x1500, opc_string("OPC_ERR_PROPERTIES")},
	{0x1501, opc_string("OPC_ERR_PROPERTIES_CREATE")},
	{0x1502, opc_string("OPC_ERR_PROPERTIES_INVALID_PROPERTY")},
	{0x1503, opc_string("OPC_ERR_PROPERTIES_ALREADY_REGISTERED")},
	{0x1504, opc_string("OPC_ERR_PROPERTIES_ID_USED")},
	{0x1505, opc_string("OPC_ERR_PROPERTIES_LIMIT_EXCEEDED")},
	{0x1510, opc_string("OPC_ERR_PROPERTY")},
	{0x1511, opc_string("OPC_ERR_PROPERTY_CREATE")},
	{0x1600, opc_string("OPC_ERR_FRONTEND")},
	{0x1601, opc_string("OPC_ERR_FRONTEND_CREATE")},
	{0x1602, opc_string("OPC_ERR_FRONTEND_REQUEST")},
	{0x1603, opc_string("OPC_ERR_FRONTEND_REQUEST_CREATE")},
	{0x1604, opc_string("OPC_ERR_FRRONTED_REQUEST_INVALID")},
	{0x1610, opc_string("OPC_ERR_XLIB")},
	{0x1611, opc_string("OPC_ERR_XLIB_CREATE")},
	{0x1612, opc_string("OPC_ERR_XLIB_COMMANDS_INIT")},
	{0x1613, opc_string("OPC_ERR_XLIB_INVALID_SCHEMA")},
	{0x1614, opc_string("OPC_ERR_XLIB_PARSER_CREATE")},
	{0x1650, opc_string("OPC_ERR_XLIB_REQUEST")},
	{0x1651, opc_string("OPC_ERR_XLIB_REQUEST_CREATE")},
	{0x1652, opc_string("OPC_ERR_XLIB_REQUEST_INVALID")},
	{0x1653, opc_string("OPC_ERR_XLIB_REQUEST_PARSE")},
	{0x1654, opc_string("OPC_ERR_XLIB_REQUEST_PARSE_CHUNK_TO_SMALL")},
	{0x1660, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE")},
	{0x1661, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE_EMPTY")},
	{0x1662, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE_NOTFOUND_NS")},
	{0x1681, opc_string("OPC_ERR_XLIB_REQUEST_VALIDATE_NOTFOUND_ITEMNAME")},
	{0x1670, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS")},
	{0x1671, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_UNKNOWN_REQUEST")},
	{0x1672, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_UNSUPPORTED_REQUEST")},
	{0x1673, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_INVALID_REQUEST")},
	{0x1675, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_MORE_ITEMS")},
	{0x1676, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_NOMORE_ITEMS")},
	{0x1680, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_ITEM")},
	{0x1682, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_ITEM_NOTFOUND")},
	{0x1690, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE")},
	{0x1691, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_BROWSE_FILTER")},
	{0x1692, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_VENDOR_FILTER")},
	{0x1693, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_NAME_FILTER")},
	{0x1694, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_BROWSE_INVALID_RETURNED_ELEMENTS_NUMBER")},
	{0x16A0, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT")},
	{0x16A1, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID")},
	{0x16A2, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_TIMEDOUT")},
	{0x16A3, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_BROWSE_FILTER")},
	{0x16A4, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_VENDOR_FILTER")},
	{0x16A5, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_NAME_FILTER")},
	{0x16A6, opc_string("OPC_ERR_XLIB_REQUEST_PROCESS_CONTINUATION_POINT_INVALID_ITEMNAME")},
	{0x16F0, opc_string("OPC_ERR_XLIB_REQUEST_SERIALIZE")},
	{0x16F1, opc_string("OPC_ERR_XLIB_REQUEST_SERIALIZE_START")},
	{0x16F2, opc_string("OPC_ERR_XLIB_REQUEST_SERIALIZE_FINISH")}
};
#define opc_errors_number 71
#endif /* _OPC_ERROR_C */

#endif /* _OPC_ERROR_H */
