#ifndef _OPC_INTERFACE_H
#define _OPC_INTERFACE_H

#include <dslocale.h>

#include <opc.h>
#include <opclocales.h>
#include <opcversion.h>
#include <opclocale.h>
#include <opctree.h>
#include <opcproperties.h>



struct OPCInterfaceT {
    OPCContext sctx;
    
    OPCLocale locale;
    const char *current_locale;

    char *start_time;
    
    int last_error;
};

typedef struct OPCInterfaceT *OPCInterface;


OPCInterface opcCreateInterface(OPCContext ctx);
void opcDestroyInterface(OPCInterface ctx);
const char *opcInterfaceGetVersion(OPCInterface ctx);
const char *opcInterfaceGetStartTime(OPCInterface ctx);
const char *opcInterfaceSetLocale(OPCInterface ctx, char *attr);
const char *opcInterfaceGetCharset(OPCInterface ctx);
dschar opcInterfaceGetStatusInfo(OPCInterface ctx);
dschar opcInterfaceGetVendorInfo(OPCInterface ctx);
dschar opcInterfaceGetStatus(OPCInterface ctx);
int opcInterfaceListSupportedLocales(OPCInterface ctx, OPCLocalesListFunctionT list_function, void *attr);
int opcInterfaceListSupportedInterfaces(OPCInterface ctx, OPCVersionListFunctionT list_function, void *attr);

OPCConfigurationContext opcInterfaceGetConfiguration(OPCInterface ctx);
OPCTreeContext opcInterfaceGetServerTree(OPCInterface ctx);

OPCItemContext opcInterfaceGetItem(OPCInterface ctx, const char *path, const char *name);
void opcInterfaceReturnItem(OPCInterface ctx, OPCItemContext ictx);

OPCPropertiesContext opcInterfaceGetProperties(OPCInterface ctx);

//char **opcInterfaceBrowse(OPCInterface ctx, const char *path, const char *browse_filter, const char *elementname_filter, vendor_filter);
#endif /*  _OPC_INTERFACE_H */
