#ifndef _OPC_ITEM_PROPERTIES_H
#define _OPC_ITEM_PROPERTIES_H

#include <dsmalloc.h>
#include <opcproperties.h>
#include <opcitemproperty.h>
#include <dshashtable.h>

typedef struct OPCItemPropertiesContextT *OPCItemPropertiesContext; 

struct OPCItemPropertiesContextT {
    DSMallocContext malloc;
    DSLockContext lock;

    OPCPropertyID maxid;    
    OPCPropertiesContext opcproperties;
    OPCItemPropertyContext properties;

    DSDataConverterContext converter;
    DSAllocatorContext allocator;
};
typedef struct OPCItemPropertiesContextT OPCItemPropertiesContextS; 

OPCItemPropertiesContext opcItemPropertiesCreateContext(DSMallocContext mctx);
int opcItemPropertiesInitContext(OPCItemPropertiesContext ctx, OPCPropertiesContext props);
void opcItemPropertiesFreeContext(OPCItemPropertiesContext ctx);
void opcItemPropertiesDestroyContext(OPCItemPropertiesContext ctx);

#endif /* _OPC_ITEM_PROPERTIES_H */
