#ifndef _OPC_PROPERTIES_H
#define _OPC_PROPERTIES_H

#include <dsmalloc.h>
#include <dshashtable.h>
#include <dslock.h>

#include <dsdatamanagerrep.h>

#include <opcproperty.h>

int opcPropertiesInit();
void opcPropertiesDestroy();

typedef struct OPCPropertiesContextT *OPCPropertiesContext;

struct OPCPropertiesContextT {
    DSMallocContext malloc;
    DSLockContext lock;
    DSHashTable id;
    OPCPropertyContext *properties;
    OPCPropertyID maxid;
    OPCPropertyID userid;
    OPCPropertyID curid;
};

OPCPropertiesContext opcPropertiesCreateContext(DSMallocContext mctx);
int opcPropertiesInitContext(OPCPropertiesContext ctx, unsigned long properties_hash_size, OPCPropertyID properties_maxid, OPCPropertyID properties_userid);
void opcPropertiesFreeContext(OPCPropertiesContext ctx);
void opcPropertiesDestroyContext(OPCPropertiesContext ctx);

int opcPropertiesRegisterProperty(OPCPropertiesContext ctx, OPCPropertyContext property);
int opcPropertiesRegisterPropertyByType(OPCPropertiesContext ctx, const char *name, OPCPropertyType ptype, DSBinaryType type);
int opcPropertiesRegisterPropertyByStandardType(OPCPropertiesContext ctx, const char *name, OPCPropertyType ptype, DSBinaryTypeStandard type, const void *attr);

OPCPropertyContext opcPropertiesFindProperty(OPCPropertiesContext ctx, const char *property);
OPCPropertyID opcPropertiesFindPropertyId(OPCPropertiesContext ctx, const char *property);
OPCPropertyContext opcPropertiesGetProperty(OPCPropertiesContext ctx, OPCPropertyID id);

OPCPropertyID opcPropertiesGetLastID(OPCPropertiesContext ctx); /* +1 */


#endif /* _OPC_PROPERTIES_H */
