#define _OPC_QUALITY_C

#include <dsassert.h>

#include <opcquality.h>



OPCQuality opcQualityCreate(DSMallocContext mctx, OPCQualityField quality, OPCLimitField limit, uint8_t vendor) {
    OPCQuality ctx;
    
    ctx = (OPCQuality)dsMalloc(mctx, sizeof(struct OPCQualityT));
    if (ctx) {
	ctx->quality = quality;
	ctx->limit = limit;
	ctx->vendor = vendor;
    }
    return ctx;
}


int opcQualitySet(OPCQuality ctx, OPCQualityField quality, OPCLimitField limit, uint8_t vendor) {
    ds_assert_param(ctx);
    
    ctx->quality = quality;
    ctx->limit = limit;
    ctx->vendor = vendor;
    return 0;
}


int opcQualityCopy(OPCQuality dst, OPCQuality src) {
    ds_assert_param(dst);
    ds_assert_param(src);
    
    memcpy(dst, src, sizeof(struct OPCQualityT));
    return 0;
}
