#ifndef _OPC_REQUEST_H
#define _OPC_REQUEST_H

enum OPCRequestTypeT {
    OPC_REQUEST_READ = 0,
    OPC_REQUEST_WRITE,
    OPC_REQUEST_READ_PROPERTY,
    OPC_REQUEST_SUBSCRIBE
};
typedef enum OPCRequestTypeT OPCRequestType;

struct OPCRequestContextT {
    task?
    DSTimeS next_start;
    DSTimeS next_deadline;
    DSTimeS cancel_deadline;
    DSDurationS period;
    
    DSDataComplexS data;
    OPCUserInfoS info;
    
    OPCRequestContext next;
};


OPCRequestContext opcRequestCreateContext(OPCMallocContext malloc);
int opcRequestInitContext(OPCRequestContext ctx, OPCRequestType type);
void opcRequestFreeContext(OPCRequestContext ctx);
void opcRequestDestroyContext(OPCRequestContext ctx);

int opcRequestAdd(OPCRequestContext ctx, const char *path, const char *name, OPCUserInfo info, DSDataComplex data);



opcRequestQueue(OPCRequestContext ctx);
opcRequestWait(OPCRequestContext ctx);
opcRequestCancel(OPCRequestContext ctx);


#endif /* _OPC_REQUEST_H */