#ifndef _OPC_STATE_H
#define _OPC_STATE_H


typedef struct OPCStateContextT *OPCStateContext;

#include <dslocale.h>
#include <dslock.h>
#include <opc.h>
#include <dsmalloc.h>


enum OPCStateT {
    OPC_STATE_RUNNING = 0,
    OPC_STATE_FAILED,
    OPC_STATE_NOCONFIG,
    OPC_STATE_SUSPENDED,
    OPC_STATE_TEST,
    OPC_STATE_COMMFAULT,
    OPC_STATE_LASTSTATE
};
typedef enum OPCStateT OPCState;

#ifdef _OPC_STATE_C
static char *opc_states[OPC_STATE_LASTSTATE] = { 
    opc_string("running"), 
    opc_string("failed"),
    opc_string("noConfig"), 
    opc_string("suspended"), 
    opc_string("test"), 
    opc_string("commFault")
};
#endif /* _OPC_REQUESTPROCESS_C */

struct OPCStateContextT {
    DSMallocContext malloc;
    DSLockContext lock;
    OPCState state;
    dslchar status_info;
    dslchar vendor_info;
};

OPCStateContext opcStateCreateContext(DSMallocContext mctx);
int opcStateInitContext(OPCStateContext ctx, OPCContext sctx);
void opcStateFreeContext(OPCStateContext ctx);
void opcStateDestroyContext(OPCStateContext ctx);

int opcStateSetStatus(OPCStateContext ctx, OPCState state, const char *status);
int opcStateSetVendor(OPCStateContext ctx, const char *vendor);

dschar opcStateGetStatusInfo(OPCStateContext ctx, const char *locale);
dschar opcStateGetVendorInfo(OPCStateContext ctx, const char *locale);
dschar opcStateGetStatus(OPCStateContext ctx, const char *locale);

#endif /* _OPC_STATE_H */
