#ifndef _OPC_XMLDA_REQUESTBROWSE_H
#define _OPC_XMLDA_REQUESTBROWSE_H

#include <dsstringlist.h>
#include <dsxml.h>
#include <opcxmldarequest.h>
#include <opcitem.h>

struct OPCXmldaRequestBrowseContextT {
    xmlChar *item;			// OPC Item identifier
    OPCTreeContext tree;
    DSStringList subitems;
    DSStringList position;

    OPCItemBrowseFilter browse_filter;
    xmlChar *name_filter;
    xmlChar *vendor_filter;
    
    unsigned char return_all_properties;
    unsigned char return_property_values;
    unsigned char return_error_text;
    
    unsigned long max_elements_returned;

// property_names???
    const char* locale;
};

typedef struct OPCXmldaRequestBrowseContextT *OPCXmldaRequestBrowseContext;



OPCXmldaRequestBrowseContext opcXmldaRequestBrowseCreateContext();
int opcXmldaRequestBrowseInitContext(OPCXmldaRequestBrowseContext ctx, OPCXmldaRequestContext rctx, xmlNodePtr node);
int opcXmldaRequestBrowseCheckContext(OPCXmldaRequestBrowseContext ctx, OPCXmldaRequestContext rctx, xmlNodePtr node);
void opcXmldaRequestBrowseFreeContext(OPCXmldaRequestBrowseContext ctx);
void opcXmldaRequestBrowseDestroyContext(OPCXmldaRequestBrowseContext ctx);

int opcXmldaRequestBrowseNextElement(OPCXmldaRequestBrowseContext ctx, xmlNodePtr pnode);
int opcXmldaRequestBrowseAnswer(OPCXmldaRequestBrowseContext ctx, xmlNodePtr pnode);

#endif /* _OPC_XMLDA_REQUESTBROWSE_H */
