#ifndef _OPC_XMLDA_REQUESTPOOL_H
#define _OPC_XMLDA_REQUESTPOOL_H

#include <opc.h>
#include <opcxmldarequest.h>

#include <dsxml.h>
#include <dshashtable.h>
#include <dsmalloc.h>

struct OPCXmldaRequestPoolContextT {
    DSMallocContext malloc;
    OPCXmldaRequestContext *pool;		// Not used realy, just for fun
    OPCContext sctx;

    xmlSchemaParserCtxtPtr schema_parser;
    xmlSchemaPtr schema_rep;
    xmlSchemaValidCtxtPtr schema_ctx;

    DSHashTable opc_commands;
};

typedef struct OPCXmldaRequestPoolContextT *OPCXmldaRequestPoolContext;

OPCXmldaRequestPoolContext opcXmldaRequestPoolCreateContext(DSMallocContext mctx);
int opcXmldaRequestPoolInitContext(OPCXmldaRequestPoolContext ctx, OPCContext sctx);
void opcXmldaRequestPoolFreeContext(OPCXmldaRequestPoolContext ctx);
void opcXmldaRequestPoolDestroyContext(OPCXmldaRequestPoolContext ctx);
OPCXmldaRequestContext opcXmldaRequestPoolGetRequest(OPCXmldaRequestPoolContext ctx);
int opcXmldaRequestPoolReturnRequest(OPCXmldaRequestPoolContext ctx, OPCXmldaRequestContext rctx);

#endif /* _OPC_XMLDA_REQUESTPOOL_H */
