#ifndef _OPC_XMLDA_REQUESTPROCESS_H
#define _OPC_XMLDA_REQUESTPROCESS_H

#include <opcxmldarequest.h>

int opcXmldaRequestProcessOPC(OPCXmldaRequestContext ctx);

struct OPCCommandsT {
    char *name;
    int (*func)(OPCXmldaRequestContext ctx);
};

typedef struct OPCCommandsT *OPCCommand;

#define OPC_COMMANDS 20

int opcXmldaRequestGetStatus(OPCXmldaRequestContext ctx);
int opcXmldaRequestBrowse(OPCXmldaRequestContext ctx);
int opcXmldaRequestGetProperties(OPCXmldaRequestContext ctx);
int opcXmldaRequestRead(OPCXmldaRequestContext ctx);
int opcXmldaRequestSubscribe(OPCXmldaRequestContext ctx);
int opcXmldaRequestSubscriptionPolledRefresh(OPCXmldaRequestContext ctx);
int opcXmldaRequestSubscriptionCancel(OPCXmldaRequestContext ctx);
int opcXmldaRequestWrite(OPCXmldaRequestContext ctx);

#ifdef _OPC_XMLDA_REQUESTPOOL_C
static const struct OPCCommandsT opc_commands_ctx[] = {
    {"GetStatus",&opcXmldaRequestGetStatus},
    {"Browse",&opcXmldaRequestBrowse},
    {"GetProperties",&opcXmldaRequestGetProperties},
    {"Read",&opcXmldaRequestRead},
    {"Subscribe",&opcXmldaRequestSubscribe},
    {"SubscriptionPolledRefresh",&opcXmldaRequestSubscriptionPolledRefresh},
    {"SubscriptionCancel",&opcXmldaRequestSubscriptionCancel},
    {"Write",&opcXmldaRequestWrite},
    {NULL,NULL}
};

#endif /* _OPC_COMMANDS_INCLUDE */

#endif /* _OPC_XMLDA_REQUESTPOOL_H */
