#define _DS_INCLUDE_XML_HEADERS

#include <stdio.h>
#include <libxml/tree.h>

#include <opclib.h>
#include <dsassert.h>

#include <opcxmldarequesttools.h>


xmlChar *opcXmldaRequestGetItemName(xmlNodePtr node) {
    int size = 2;
    xmlChar *name, *path;
    xmlChar *tmp;
    
    ds_assert_null(node);
    
    name=xmlGetProp(node,"ItemName");
    path=xmlGetProp(node,"ItemPath");

    if (name) size+=xmlStrlen(name);
    if (path) size+=xmlStrlen(path);

    tmp = (xmlChar*)malloc((size)*sizeof(xmlChar));
    if (!tmp) return NULL;
    
    if ((name)&&(path)) {
	if ((name[0]=='/')||((!*name)&&(!*path))) xmlStrPrintf(tmp,size,"%s%s",name,path);
	else xmlStrPrintf(tmp,size,"%s/%s",name,path);
	xmlFree(name);
	xmlFree(path);
	return tmp;
    } else if (name) {
	if ((name[0]=='/')||(name[0]==0)) return name;
	xmlStrPrintf(tmp,size,"/%s",name);
	xmlFree(name);
	return tmp;
    } else if (path) return path;
    return xmlStrdup("");
}
