#! /bin/bash

rm -f core.*

RDIR=~/releases


if [ ! -d $RDIR ]; then
    if [ -a $RDIR ]; then
	echo "Release directory isn't a directory!"
	exit
    fi
    mkdir -p $RDIR
fi

version=`cat VERSION | perl -e "while (<STDIN>) {  if (m/(\d+\.\d+(.\d+)?)/) { print \\$1; } }"`
cvs=`cat VERSION | perl -e "while (<STDIN>) {  if (m/\d+\.\d+(.\d+)?.*(cvs|CVS|Cvs)/) { print 'cvs'; } }"`
if [ "$cvs" == "cvs" ]; then
    rname="opc-`date +%y%m%d.%H`"
else
    rname="opc-$version";
fi
if [ -d $RDIR/$rname ]; then
    rm -rf $RDIR/$rname
fi
mkdir -p $RDIR/$rname
if [ ! -d $RDIR/$rname ]; then
    echo "Can't create directory!!!"
    exit
fi
cp -a * $RDIR/$rname
#cp -al * $RDIR/$rname

(
    cd $RDIR/$rname
    make clean
    make clean -C mod_opc
    rm -rf dsintl/autom4te*.cache
    rm -rf "{arch}"
    rm -rf `find . -name .arch-ids`
    rm -rf win32/*.exe
    rm -rf win32/*.lib
    rm -rf win32/*.obj
    rm -rf win32/obj/*
    rm -rf win32/vc/ds/ds.ncb
    rm -rf win32/vc/ds/Debug/*
    rm -rf win32/vc/libopc/Debug/*
    rm -rf win32/vc/opcsrv/Debug/*
    rm -rf win32/vc/example1/Debug/*
    rm -rf data/*.log
#    Include in release to simplify Win builds
#    rm -rf win32/Makefile.tmp.*
    cd ..
    if [ -a $rname.tar.bz2 ]; then
	rm -f $rname.tar.bz2
    fi
    tar cjf $rname.tar.bz2 $rname
    rm -rf $rname
    scp $rname.tar.bz2 csa@darksoft.org:/home/csa/public_html/files/adas/
)
