#ifndef _BACKEND_H
#define _BACKEND_H

#include <opc.h>
#include <dspluginset.h>
#include <dsconnectionserver.h>

#include <opcconfig.h>

typedef struct OPCBackendContextT *OPCBackendContext;

struct OPCBackendContextT {
    OPCConfigContext config;
    DSSignalContext sigctx;
    
    DSMallocContext malloc;
    DSPluginSetContext plugins;
    
    OPCContext sctx;
};
typedef struct OPCBackendContextT OPCBackendContextS;

OPCBackendContext opcBackendCreateContext(DSMallocContext mctx);
int opcBackendInitContext(OPCBackendContext ctx, OPCConfigContext config, OPCContext sctx, DSSignalContext sigctx);
int opcBackendInitSocket(OPCBackendContext ctx, const char *socket_name);
void opcBackendFreeContext(OPCBackendContext ctx);
void opcBackendDestroyContext(OPCBackendContext ctx);
int opcBackendListen(OPCBackendContext ctx);

#endif /* _BACKEND_H */
