#ifndef _FRONTEND_H
#define _FRONTEND_H

typedef struct OPCFrontendContextT *OPCFrontendContext;

#include <opcconfig.h>
#include <opcxmldarequestpool.h>

#include <dsbufferpool.h>
#include <dssignal.h>
#include <dslock.h>
#include <dsmalloc.h>

#include <frontendchild.h>

struct OPCFrontendContextT {
    DSMallocContext malloc;
    OPCConfigContext config;
    DSConnectionServerContext consrv;
    DSSignalContext sigctx;
    DSBufferPoolContext buffpool;
    OPCXmldaRequestPoolContext rpctx;
    DSLockContext lock;
    OPCFrontendChildContext *child;
};
typedef struct OPCFrontendContextT OPCFrontendContextS;

OPCFrontendContext opcFrontendCreateContext(DSMallocContext mctx);
int opcFrontendInitContext(OPCFrontendContext ctx, OPCConfigContext config, OPCXmldaRequestPoolContext rpctx, DSBufferPoolContext bp, DSSignalContext sigctx);
void opcFrontendFreeContext(OPCFrontendContext ctx);
void opcFrontendDestroyContext(OPCFrontendContext ctx);
int opcFrontendListen(OPCFrontendContext ctx);
void opcFrontendCleanupChilds(OPCFrontendContext ctx);

#endif /* _FRONTEND_H */
