#ifndef _FRONTENDCHILD_H
#define _FRONTENDCHILD_H

#include <dsmalloc.h>
#include <dslock.h>
#include <dscondition.h>
#include <dsdoublethread.h>
#include <dsconnection.h>

typedef struct OPCFrontendChildContextT *OPCFrontendChildContext;

#include <frontend.h>
#include <opcxmldarequestpool.h>
#include <opcxmldarequest.h>

#include <dsbufferpool.h>

#define opc_frontend_child_waittime 1

#define OPC_FRONTEND_CHILD_ENDEVENT_FLAG 256

struct OPCFrontendChildBPT {
    DSBufferPoolBuffer buffer;
    unsigned long size;
    struct OPCFrontendChildBPT *next;
};

typedef struct OPCFrontendChildBPT *OPCFrontendChildBP;

struct OPCFrontendChildContextT {
    struct DSDoubleThreadContextT dtc;

    DSConnectionContext con;    
    char *hostname;
    char *username;
    
    OPCFrontendContext fctx;
    DSBufferPoolContext buffpool;
    DSBufferPoolBuffer buffer;
    OPCFrontendChildBP lbp;

    DSLockContext lbp_lock;
    DSLockContext error_lock;
    
    OPCXmldaRequestPoolContext rpctx;
    OPCXmldaRequestContext rctx;
    
    int err;
    
    unsigned char format;	/* 0 - no attachments, 1,2 - DIME with attachments */
};
typedef struct OPCFrontendChildContextT OPCFrontendChildContextS;

OPCFrontendChildContext opcFrontendChildCreateContext(DSMallocContext mctx);
int opcFrontendChildInitContext(OPCFrontendChildContext ctx, OPCFrontendContext fctx, DSConnectionContext con);
void opcFrontendChildFreeContext(OPCFrontendChildContext ctx);
void opcFrontendChildDestroyContext(OPCFrontendChildContext ctx);
void opcFrontendChildClear(OPCFrontendChildContext ctx);

int opcFrontendChildReader(OPCFrontendChildContext ctx);
int opcFrontendChildParser(OPCFrontendChildContext ctx);

#endif /* _FRONTENDCHILD_H */
