
/* RCS_Id: httputil.h 10.2 1999/12/10 16:44:03 clark Exp $ */

/*
 * RCS_Log: httputil.h $
 * Revision 10.2  1999/12/10  16:44:03  clark
 * clean up, added memory debug #defines
 * 
 * Revision 10.1  1999/12/09  14:53:14  clark
 * conditionally compile some structs to avoid needing winsock.h
 * 
 * Revision 10.0  1999/12/07  16:26:22  clark
 * *** empty log message ***
 * 
 * Revision 1.2  1998/02/05  17:46:03  mark
 * Changed the MULTIPART_FORM_DATA define to compensate for the boundary variable
 * being more or less than one space after the content-type.
 * 
 * Revision 1.1  1997/05/07  13:32:39  mark
 * Initial revision
 * 
 */

//
// httputil.h
//
// Public defines, structures, and functions shared between the modules in this
// directory.
//

#ifndef ETS_HTTP_INCLUDED

#define ETS_HTTP_INCLUDED

  /////////////
 // Defines //
/////////////

//
// These defines are the strings that mark the type of form we are dealing
// with.  These strings are found in the pContentType field of the REQ_INPUTS
// structure.
//
#define FORM_URL_ENCODED    "application/x-www-form-urlencoded"
#define MULTIPART_FORM_DATA "multipart/form-data;"

// Non-alphanumeric characters are expressed as hex numbers preceded by a '%'.
#define NONALPHA_CHAR_BASE	16


  //////////////////////////////////
 // Public Function Declarations //
//////////////////////////////////

// only if winsock.h has been included
#ifdef _WINSOCKAPI_
//
// From multpost.c
//
short GetMultiPartPostInfo (REQ_INPUTS *pInp) ;

//
// From urlpost.c
//
short GetURLEncodedPostInfo (REQ_INPUTS *pInp) ;
#endif

//
// From utils.c
//
char	*SetNewString(char *pSourceStr, DWORD SourceLen);
char	*BuildNewQueryString(char *pQuery, DWORD *QueryLen,
			     BOOL fMoreToAppend);

// debug memory allocs/frees
#ifdef DBGMEM
#undef malloc
#undef free
#define	malloc	_http_malloc
#define free	_http_free

void *	__cdecl	_http_malloc(size_t);
void	__cdecl	_http_free(void *);

#endif

#endif // ETS_HTTP_INCLUDED
