#ifndef _OPC_CONFIG_H
#define _OPC_CONFIG_H

#include <opclib.h>
#include <dsdebug.h>
#include <opcdefines.h>
#include <opcconfiguration.h>

typedef struct OPCConfigContextT *OPCConfigContext;
typedef struct OPCConfigContextT OPCConfigContextS;

struct OPCConfigContextT {
    OPCConfigurationContextS opc;
    
    DSDebugPriority debug_level;
    
    char srvname[MAX_SERVER_NAME];
    char *srvpath;
    in_port_t srvport;

    unsigned long max_frontend_threads;
};

OPCConfigContext opcConfigCreateContext(DSMallocContext mctx);
int opcConfigInitContext(OPCConfigContext ctx, const char *data_directory, const char *config);
void opcConfigFreeContext(OPCConfigContext ctx);
void opcConfigDestroyContext(OPCConfigContext ctx);



#ifdef _OPC_CONFIG_C
# define OPC_SERVER_CONFIG_SCALE_FACTOR			10
# define OPC_SERVER_CONFIG_DEFAULT_NAME			"FZK.opc"
# define OPC_SERVER_CONFIG_SERVERS_DIRECTORY		"servers"
#endif /* _OPC_CONFIG_C */

#endif /* _OPC_CONFIG_H */
