#ifndef _OPCSERVER_H
#define _OPCSERVER_H

typedef struct OPCServerContextT* OPCServerContext;
#include <dsmalloc.h>

#include <opc.h>
#include <opcxmldarequestpool.h>
#include <dsbufferpool.h>
#include <dssignal.h>

#include <opcconfig.h>

#ifdef OPC_EMBEDED_HTTP
#else
#include <frontend.h>
#endif /* OPC_EMBEDED_HTTP */

#include <backend.h>


#define OPC_SERVER_NO_FRONTEND 1
#define OPC_SERVER_NO_BACKEND 2

#define OPC_SERVER_BACKEND_INITIALIZED 1
#define OPC_SERVER_FRONTEND_INITIALIZED 2
#define OPC_SERVER_TERMINATE_FLAG 4
#define OPC_SERVER_CONTEXT_INITIALIZED 8

struct OPCServerContextT {
    DSMallocContext malloc;
    OPCConfigContext config;
    OPCContext ctx;
    DSThreadContext frontend;
#ifdef OPC_EMBEDED_HTTP
#else
    OPCFrontendContext fctx;
#endif /* ! OPC_EMBEDED_HTTP */
    DSThreadContext backend;
    OPCBackendContext bctx;
    OPCXmldaRequestPoolContext rpctx;
    DSBufferPoolContext buffpool;
    DSSignalContext sigctx;
    unsigned char status;
};

int opcServerInit();
void opcServerDestroy();

OPCServerContext opcServerCreateContext();
int opcServerInitContext(OPCServerContext ctx, const char *opc_directory, unsigned char setup);
void opcServerFreeContext(OPCServerContext ctx);
void opcServerDestroyContext(OPCServerContext ctx);
int opcServerRun(OPCServerContext ctx);
int opcServerTerminate(OPCServerContext ctx);
int opcServerIsTerminating(OPCServerContext ctx);
void opcServerMantain(OPCServerContext ctx);

#endif /* _OPCSERVER_H */
